SystemOrganization addCategory: #'Pier-Importer-Tests'!
SystemOrganization addCategory: #'Pier-Importer'!

TestRunner subclass: #PRSwikiImporterTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRSwikiImporterTestRunner methodsFor: 'initialize' stamp: 'FW 6/18/2005 23:52'!
testCases
	"I overwrite from TestRunner in order that only the methods from Pier-Importer are displayed"

	^(Set new)
		add: PRSwikiPageWrapperTest;
		add: PRSwikiLinkParserTest;
		add: PRTreeImporterTest;
		add: PRImporterTest;
		add: PRConnectionProviderTest;
		yourself! !

!PRSwikiImporterTestRunner methodsFor: 'constants' stamp: 'FW 6/14/2005 20:56'!
windowLabel
	^'Swiki-Importer Test Runner'.! !

SmaCCParser subclass: #PRLinkParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

PRLinkParser subclass: #PRFlatLinkParser
	instanceVariableNames: 'path'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRFlatLinkParser commentStamp: '<historical>' prior: 0!
I adapt the links for the FlatImporter!

!PRFlatLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:39'!
addInternalLink: aString
	| target |
	target := aString copyFrom: 2 to: aString size - 1.
	
	"Create an absolute url and an alias"
	self stream nextPutAll: '*'.
	self stream nextPutAll: target.
	self stream nextPutAll: '>'.
	self stream nextPutAll: self path.
	self stream nextPutAll: target.
	self stream nextPutAll: '*'.! !

!PRFlatLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:39'!
addInternalLinkWithAlias: aString
	| link |
	
	link := aString copyReplaceAll: '>' with: ('>', self path) asTokens: false.
	self stream nextPutAll: link.
! !

!PRFlatLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:39'!
path
	path isNil
		ifTrue: [path := '/'].
		
	^path
			! !

!PRFlatLinkParser methodsFor: 'accessing' stamp: 'mim 6/17/2005 13:39'!
path: aString
	path := aString! !

!PRLinkParser class methodsFor: 'generated-comments' stamp: 'mim 6/17/2005 09:33'!
parserDefinitionComment

	"Document 
	: DocumentItems;
	
DocumentItems 
	: #nothing
	| DocumentItem
	| DocumentItems NewLine DocumentItem
	| DocumentItems BlankLine DocumentItem
	| DocumentItems NewLine 
	| DocumentItems BlankLine ;
	
NewLine
	: <newline> 'newline' { self addText: newline value };

BlankLine 
	: <blankline> 'blankline' { self addText: blankline value };

DocumentItem 
	: AnchorTarget 
	| Paragraph ;

	
AnchorTarget
	: <anchorTarget> 'target' { self addAnchorTarget: target value };
	
Paragraph 
	: ParagraphStart ParagraphItems ;
	
ParagraphStart 
	: <nonLinkStart> 'string' { self addText: string value }
	| Email
	| LinkHttp
	| LinkFtp
	| LinkFile
	| Link
	| LinkWithAlias
	| Anchor
	| AnchorWithAlias
	| RemoteAnchor
	| RemoteAnchorWithAlias
	| <any> 'string' { self addText: string value } 
	| Text ;
	
ParagraphItems
	: 
	| ParagraphItems <nonLinkStart> 
	| ParagraphItems Email
	| ParagraphItems LinkHttp 
	| ParagraphItems LinkFtp 
	| ParagraphItems LinkFile 
	| ParagraphItems Link 
	| ParagraphItems LinkWithAlias 
	| ParagraphItems Anchor
	| ParagraphItems AnchorWithAlias
	| ParagraphItems RemoteAnchor
	| ParagraphItems RemoteAnchorWithAlias
	| <any> 'string' { self addText: string value } 
	| ParagraphItems Text ;

Email
	: <email> 'email' { self addEmail: email value } ;
	
LinkHttp
	: <linkHttp> 'link' { self addHttpLink: link value } ;

LinkFtp
	: <linkFtp> 'link' { self addFtpLink: link value } ;

LinkFile
	: <linkFile> 'link' { self addInternalFileLink: link value } ;
			
Link
	: <link> 'link' { self addInternalLink: link value } ;

LinkWithAlias
	:<linkWithAlias> 'link' { self addInternalLinkWithAlias: link value } ;

Anchor
	:<anchor> 'link' { self addAnchor: link value } ;

AnchorWithAlias
	:<anchorWithAlias> 'link' { self addAnchorWithAlias: link value } ;
	
RemoteAnchor
	:<remoteAnchor> 'link' { self addRemoteAnchor: link value } ;

RemoteAnchorWithAlias
	:<remoteAnchorWithAlias> 'link' { self addRemoteAnchorWithAlias: link value } ;
		
Text
	: <text> 'text' { self addText: text value };
"! !

!PRLinkParser class methodsFor: 'generated-accessing' stamp: 'mim 6/17/2005 13:43'!
scannerClass
	^PRLinkScanner! !

!PRLinkParser class methodsFor: 'generated-starting states' stamp: 'mim 6/17/2005 09:33'!
startingStateForDocument
	^1! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:44'!
addAnchor: aString
	"This is a page internal anchor. Here we remove the anchor @
	and add a comment."
	
	| link |
	
	link := aString copyFrom: 3 to: aString size - 1.
	self stream nextPutAll: link.
	self stream nextPutAll: ' <i>(This was an anchor)</i>'.! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:45'!
addAnchorTarget: aString
	"Remove anchor targets"
! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/13/2005 23:38'!
addAnchorWithAlias: aString
	"This is a page internal anchor with alias. 
	Here we remove the anchor part and add
	insert a bold line instead."
	
	| link index anchor |
	
	link := aString copyFrom: 2 to: aString size - 1.
	index := link findString: '@'.
	anchor := link copyFrom: index to: link size.
	link := link copyReplaceAll: '>', anchor with: '' asTokens: false.
	self stream nextPutAll: '<b>'.
	self stream nextPutAll: link.
	self stream nextPutAll: '</b>'.! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/13/2005 22:55'!
addEmail: aString
	self stream nextPutAll: aString
! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/9/2005 19:44'!
addFtpLink: aString
	self stream nextPutAll: aString! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/9/2005 19:44'!
addHttpLink: aString
	self stream nextPutAll: aString! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/9/2005 21:32'!
addInternalFileLink: aString
	self stream nextPutAll: aString! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:47'!
addInternalLink: aString
	self stream nextPutAll: aString! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/17/2005 13:47'!
addInternalLinkWithAlias: aString
	self stream nextPutAll: aString! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/13/2005 23:23'!
addRemoteAnchor: aString
	"This was a anchor that was linked to a other page.
	We remove the anchor part and link to the other page."
	
	| link index anchor |
	
	link := aString copy.
	index := link findString: '@'.
	anchor := link copyFrom: index to: link size - 1.
	link := link copyReplaceAll: anchor with: '' asTokens: false.
	self stream nextPutAll: link.! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/13/2005 23:16'!
addRemoteAnchorWithAlias: aString
	"For this kind of anchor we just remove the anchor part
	from the url"
	
	| link index anchor |
	
	link := aString copy.
	index := link findString: '@'.
	anchor := link copyFrom: index to: link size - 1.
	link := link copyReplaceAll: anchor with: '' asTokens: false.
	self stream nextPutAll: link.

! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/9/2005 16:23'!
addText: aString
	self stream nextPutAll: aString! !

!PRLinkParser methodsFor: 'accessing' stamp: 'mim 6/16/2005 18:07'!
contents
	^self stream contents! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForAnchor1: nodes 
	^self addAnchor: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForAnchorTarget1: nodes 
	^self addAnchorTarget: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForAnchorWithAlias1: nodes 
	^self addAnchorWithAlias: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForBlankLine1: nodes 
	^self addText: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForEmail1: nodes 
	^self addEmail: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForLink1: nodes 
	^self addInternalLink: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForLinkFile1: nodes 
	^self addInternalFileLink: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForLinkFtp1: nodes 
	^self addFtpLink: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForLinkHttp1: nodes 
	^self addHttpLink: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForLinkWithAlias1: nodes 
	^self addInternalLinkWithAlias: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForNewLine1: nodes 
	^self addText: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForParagraphItems13: nodes 
	^self addText: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForParagraphStart12: nodes 
	^self addText: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForParagraphStart1: nodes 
	^self addText: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForRemoteAnchor1: nodes 
	^self addRemoteAnchor: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForRemoteAnchorWithAlias1: nodes 
	^self addRemoteAnchorWithAlias: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-reduction actions' stamp: 'mim 6/17/2005 09:33'!
reduceActionForText1: nodes 
	^self addText: (nodes at: 1) value! !

!PRLinkParser methodsFor: 'generated-tables' stamp: 'mim 6/17/2005 09:33'!
reduceTable
	^#(
#(17 1 #reduceActionForLinkFtp1:)
#(18 1 #reduceActionForEmail1:)
#(19 1 #reduceActionForLink1:)
#(20 1 #reduceActionForLinkWithAlias1:)
#(21 1 #reduceActionForAnchor1:)
#(22 1 #reduceActionForAnchorWithAlias1:)
#(23 1 #reduceActionForRemoteAnchor1:)
#(24 1 #reduceActionForRemoteAnchorWithAlias1:)
#(25 1 #reduceActionForLinkHttp1:)
#(26 1 #reduceActionForText1:)
#(27 0 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 2 #reduceFor:)
#(27 1 #reduceActionForParagraphItems13:)
#(27 2 #reduceFor:)
#(28 1 #reduceActionForParagraphStart1:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceFor:)
#(28 1 #reduceActionForParagraphStart12:)
#(28 1 #reduceFor:)
#(29 2 #reduceFor:)
#(30 1 #reduceActionForAnchorTarget1:)
#(31 1 #reduceActionForBlankLine1:)
#(32 1 #reduceActionForNewLine1:)
#(33 1 #reduceFor:)
#(33 1 #reduceFor:)
#(34 1 #reduceFor:)
#(35 1 #reduceFor:)
#(36 1 #reduceActionForLinkFile1:)
#(37 0 #reduceFor:)
#(37 1 #reduceFor:)
#(37 3 #reduceFor:)
#(37 3 #reduceFor:)
#(37 2 #reduceFor:)
#(37 2 #reduceFor:)
)! !

!PRLinkParser methodsFor: 'private' stamp: 'mim 6/9/2005 16:52'!
stream
	stream isNil
		ifTrue: [stream := WriteStream on: String new].
		
	^stream
			! !

!PRLinkParser methodsFor: 'generated-tables' stamp: 'mim 6/17/2005 09:33'!
transitionTable
	^#(
#(3 190 1 190 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 53 14 57 15 61 16 65 17 69 18 73 19 77 20 81 21 85 22 89 23 93 24 97 25 101 26 105 28 109 29 113 30 117 33 121 35 125 36 129 37 190 38)
#(2 158 1 2 38)
#(2 10 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 38 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 6 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 186 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 14 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 18 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 22 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 30 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 26 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 34 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 102 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 42 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 146 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 114 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 106 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 122 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 126 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 130 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 134 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 138 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 142 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 110 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 150 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(3 46 1 46 2 46 4 46 5 46 6 46 7 46 8 46 9 46 10 46 11 46 12 46 13 46 14 46 15 133 16 137 27 46 38)
#(2 174 1 2 38)
#(2 170 1 2 38)
#(2 194 1 2 38)
#(2 0 38)
#(2 118 1 2 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(3 141 1 145 2 149 31 153 32 182 38)
#(2 94 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(3 154 1 154 2 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 157 14 57 15 161 17 165 18 169 19 173 20 177 21 181 22 185 23 189 24 193 25 197 26 201 36 154 38)
#(2 166 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(2 162 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 38)
#(3 210 1 210 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 53 14 57 15 61 16 65 17 69 18 73 19 77 20 81 21 85 22 89 23 93 24 97 25 101 26 105 28 109 29 113 30 205 33 125 36 210 38)
#(3 206 1 206 2 9 3 13 4 17 5 21 6 25 7 29 8 33 9 37 10 41 11 45 12 49 13 53 14 57 15 61 16 65 17 69 18 73 19 77 20 81 21 85 22 89 23 93 24 97 25 101 26 105 28 109 29 113 30 209 33 125 36 206 38)
#(2 50 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 62 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 54 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 70 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 74 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 78 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 82 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 86 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 90 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 58 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 98 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 66 1 2 4 5 6 7 8 9 10 11 12 13 14 15 38)
#(2 202 1 2 38)
#(2 198 1 2 38)
)! !

PRVisitor subclass: #PRLinkUpdateVisitor
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRLinkUpdateVisitor commentStamp: '<historical>' prior: 0!
After importing the swiki pages we need to visit every page and reparse the contents. Otherwise
the links between the pages will be brocken.!

!PRLinkUpdateVisitor methodsFor: 'accessing' stamp: 'rw 6/16/2005 16:41'!
context
	^context! !

!PRLinkUpdateVisitor methodsFor: 'accessing' stamp: 'rw 6/16/2005 16:41'!
context: anObject
	context := anObject! !

!PRLinkUpdateVisitor methodsFor: 'visiting' stamp: 'mim 4/16/2005 12:01'!
visitChildrenDecoration: anObject
	self visitAll: anObject children.! !

!PRLinkUpdateVisitor methodsFor: 'visiting' stamp: 'mim 6/16/2005 18:06'!
visitPage: aPage
	"Get the contents and set the same contents again. Like this
	the contents will be reparsed and the links should work."
	
	"| currentContext command | 
	currentContext := self context goto: aPage.
	command := PREditPageCommand context: currentContext.
	command contents: aPage contents.
	command execute."
	aPage contents: aPage contents
! !

Object subclass: #PRCommandLineImporter
	instanceVariableNames: 'url'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRCommandLineImporter commentStamp: '<historical>' prior: 0!
I import a swiki via CommandLine,for testing and debugging purposes.
CommandLineImporter new runFromUrl: 'http://scgwiki.iam.unibe.ch:8080/ESE2003'
CommandLineImporter new runFromUrl: 'http://scgwiki.iam.unibe.ch:8080/LOO'
CommandLineImporter new runFromUrl: 'http://scgwiki.iam.unibe.ch:8080/Release'
CommandLineImporter new runFromUrl: 'http://scgwiki.iam.unibe.ch:8080/SSUGWiki'
CommandLineImporter new runFromUrl: 'http://scgwiki.iam.unibe.ch:8080/SmalltalkWiki'
CommandLineImporter new runFromUrl: 'http://scgwiki.iam.unibe.ch:8080/StephaneDucasseWiki'
CommandLineImporter new run!

!PRCommandLineImporter class methodsFor: 'accessing defaults' stamp: 'FW 6/18/2005 18:13'!
defaultUrl
	^'http://localhost:8888/SCGTest'! !

!PRCommandLineImporter methodsFor: 'initialize-release' stamp: 'FW 6/18/2005 18:14'!
initialize
	self url: (self class defaultUrl)! !

!PRCommandLineImporter methodsFor: 'running' stamp: 'rw 6/17/2005 16:15'!
run
	"Start the swiki import."
	| importer kernel |
	Transcript clear.
	kernel := PRKernel instances first.
	importer := PRTreeImporter root: kernel root context: (PRContext kernel: kernel).
	importer importSwikiFromUrl: self url.! !

!PRCommandLineImporter methodsFor: 'running' stamp: 'rw 6/6/2005 11:44'!
runFromUrl: anUrl
	self url: anUrl.
	self run! !

!PRCommandLineImporter methodsFor: 'accessing' stamp: 'rw 6/6/2005 11:24'!
url
	^url! !

!PRCommandLineImporter methodsFor: 'accessing' stamp: 'rw 6/6/2005 11:24'!
url: anObject
	url := anObject! !

Object subclass: #PRConnectionProvider
	instanceVariableNames: 'htmlProvider mediaProvider'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

PRConnectionProvider class
	instanceVariableNames: 'uniqueInstance'!

!PRConnectionProvider commentStamp: '<historical>' prior: 0!
I am responsible to establish a connection to a http-server (or mock-server for testing reasons) and to get the files and medias from there.
!

PRConnectionProvider class
	instanceVariableNames: 'uniqueInstance'!

!PRConnectionProvider class methodsFor: 'as yet unclassified' stamp: 'FW 6/17/2005 16:29'!
new
	self error:'Should use uniqueInstance (Singleton)'.
   ! !

!PRConnectionProvider class methodsFor: 'as yet unclassified' stamp: 'FW 6/17/2005 16:30'!
uniqueInstance
	uniqueInstance isNil
	  ifTrue: [uniqueInstance := self basicNew initialize].
	^uniqueInstance.
   ! !

!PRConnectionProvider methodsFor: 'get the media' stamp: 'FW 6/18/2005 10:36'!
contentLength: aUrl 
	"Here we ectract the Content-length: element from the header."
	
	| header parsedHeader length |

	header := self getHeader: aUrl.
	parsedHeader := self parseHeader: header.
	[length := (parsedHeader at: 'content-length') asInteger]
		on: Error
		do: [length := 0].
		
	^ length! !

!PRConnectionProvider methodsFor: 'get the media' stamp: 'FW 6/18/2005 10:37'!
contentType: aUrl 
	"Here we ectract the Content-type:: element from the header."
	
	| header parsedHeader type |
	
	header := self getHeader: aUrl.
	parsedHeader := self parseHeader: header.
	[type := parsedHeader at: 'content-type']
		on: Error
		do: [type := 'text/plain'].
				
	^ type! !

!PRConnectionProvider methodsFor: 'get the media' stamp: 'FW 6/18/2005 10:51'!
getHeader: aUrl 
	"This method asks the server for the header"
	
	| url stream header path |
	
	url := Url absoluteFromText: aUrl.
	path := self path: url.
		
	stream := self mediaProvider openConnectionToHostNamed: url authority port: url port.
	[[stream nextPutAll: 'HEAD ';
		 nextPutAll: path contents;
		 nextPutAll: ' HTTP/1.0';
		 crlf;
		 crlf;
		 flush.
	header := stream upToAll: String crlfcrlf.]
		ensure: [stream close]]
		on: ConnectionTimedOut
		do: [:ex | 
			Transcript show: ex asString; cr.
			ex resume].
		
	^ header! !

!PRConnectionProvider methodsFor: 'accessing' stamp: 'FW 6/18/2005 10:34'!
htmlProvider
	^htmlProvider! !

!PRConnectionProvider methodsFor: 'accessing' stamp: 'FW 6/18/2005 10:50'!
htmlProvider: aProvider 
	"Set the connection provider. This can either be HTTPSocket or MockSocket"
	htmlProvider := aProvider! !

!PRConnectionProvider methodsFor: 'get the page' stamp: 'FW 6/18/2005 10:34'!
httpGet: aUrl 
	^self htmlProvider httpGet: aUrl! !

!PRConnectionProvider methodsFor: 'get the page' stamp: 'FW 6/18/2005 10:34'!
httpGet: aUrl accept: amimeType 
	^self htmlProvider 
		httpGet: aUrl
		args: nil
		accept: amimeType! !

!PRConnectionProvider methodsFor: 'get the media' stamp: 'FW 6/18/2005 10:51'!
httpGetMedia: aUrl 
	"Returns the contents of the response stream."
	
	| url stream content path |
	
	url := Url absoluteFromText: aUrl.
	path := self path: url.
		
	stream := self mediaProvider openConnectionToHostNamed: url authority port: url port.
	[[stream nextPutAll: 'HEAD ';
		 nextPutAll: path contents;
		 nextPutAll: ' HTTP/1.0';
		 crlf;
		 crlf;
		 flush.
	stream upToAll: String crlfcrlf. "Skip the header"
	content := stream upToEnd]
		ensure: [stream close]]
		on: ConnectionTimedOut
		do: [:ex | 
			Transcript show: ex asString; cr.
			ex resume].
		
	^ content! !

!PRConnectionProvider methodsFor: 'initialize-release' stamp: 'FW 6/18/2005 10:36'!
initialize
	htmlProvider := HTTPSocket.
	mediaProvider := FastSocketStream! !

!PRConnectionProvider methodsFor: 'testing' stamp: 'FW 6/18/2005 10:13'!
isLocked: anObject
	"Checks if a webpage needs authentication.
	The response code in that case is 401 or in other cases 404."
     
     |code|
     code := self responseCode: anObject.   
	^(code = '401' or: [code = '404']).! !

!PRConnectionProvider methodsFor: 'accessing' stamp: 'FW 6/18/2005 10:36'!
mediaProvider
	^mediaProvider! !

!PRConnectionProvider methodsFor: 'accessing' stamp: 'FW 6/18/2005 10:36'!
mediaProvider: anObject
	mediaProvider := anObject! !

!PRConnectionProvider methodsFor: 'get the media' stamp: 'FW 6/18/2005 10:42'!
parseHeader: headerText
	"This code comes from the original HTTPSocket class."
	
	| headers lines foldedLines i |
	
	"divide into basic lines"
	lines := headerText findTokens: (String with: Character cr  with: Character linefeed).
	lines := lines copyFrom: 2 to: lines size. "Skip the response code"

	"fold lines that start with spaces into the previous line"
	foldedLines := OrderedCollection new.
	lines do: [ :line |
		line first isSeparator ifTrue: [
			foldedLines at: foldedLines size  put: (foldedLines last, line) ]
		ifFalse: [ foldedLines add: line ] ].

	"make a dictionary mapping headers to header contents"
	headers := Dictionary new.
	foldedLines do: [ :line |
		i := line indexOf: $:.
		i > 0 ifTrue: [
			headers 
			at: (line copyFrom: 1 to: i-1) asLowercase 
			put: (line copyFrom: i+1 to: line size) withBlanksTrimmed ] ].
	
	^headers! !

!PRConnectionProvider methodsFor: 'get the media' stamp: 'FW 6/18/2005 10:43'!
path: aUrl
	"Builds a path"
	
	| path |
	path := WriteStream on: String new.
	aUrl path
		do: [:pathElem | 
			path nextPut: $/.
			path nextPutAll: pathElem encodeForHTTP].
		
	^path! !

!PRConnectionProvider methodsFor: 'testing' stamp: 'FW 6/18/2005 10:12'!
responseCode: anObject
	"anObject: Either a stream (that means the response is ok)
			  Or a string, that means we need to check the response code."
	
	| socket |
	(anObject class = String)
		ifTrue: [ socket := HTTPSocket new.
 				 socket header: anObject.
				 ^socket responseCode]! !

Object subclass: #PRImporter
	instanceVariableNames: 'root proxy context fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRImporter commentStamp: '<historical>' prior: 0!
This class organizes the import of swikis.!

PRImporter subclass: #PRFlatImporter
	instanceVariableNames: 'section'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRFlatImporter commentStamp: '<historical>' prior: 0!
I import the swikis in flat mode, that means that there is no hierarchy!

!PRFlatImporter class methodsFor: 'testing' stamp: 'FW 6/18/2005 19:29'!
isAbstract
	^false.! !

!PRFlatImporter methodsFor: 'importing' stamp: 'FW 6/18/2005 18:22'!
doImport: validUrl.
	"I override the hock method of my superclass"

	"Create a new section"
	section := PRPage new.
	section title: 'Imported Swiki'.
	section contents: 'Imported from: *', validUrl, '*'.
	section := self createPage: section parent: self root url: ''.
	
	"Import a swiki"
	self importPageFromUrl: validUrl.! !

!PRFlatImporter methodsFor: 'importing' stamp: 'rw 6/17/2005 14:31'!
importPageFromUrl: aUrl
	| sw2PageWrapper sw2Page internalLinks|
	
	(self proxy includesKey: aUrl)
		ifFalse: [
			"Create a new wikipage"
			sw2PageWrapper := self proxy getPage: aUrl.
			sw2Page :=  sw2PageWrapper asPRPage.
			sw2Page := self createPage: sw2Page parent: self section url: aUrl.
			sw2PageWrapper sw2page: sw2Page.
			
			"Import all referenzed swiki pages."
			 internalLinks := sw2PageWrapper getAllInternalLinks.
			 internalLinks 
				do: [:anUrl | self importPageFromUrl: anUrl].
				
			"import media files to wiki"
			 sw2PageWrapper getAllMedia
				do: [:anUrl | self importMedia: anUrl page: sw2Page].
				
			self updateLinks: sw2Page]
! !

!PRFlatImporter methodsFor: 'private' stamp: 'mim 6/10/2005 13:16'!
section
	^section! !

!PRFlatImporter methodsFor: 'private' stamp: 'FW 6/18/2005 18:21'!
section: anObject
	section := anObject! !

!PRFlatImporter methodsFor: 'accessing' stamp: 'FW 6/10/2005 16:26'!
startPRPage
	"I override the hock method of my superclass"

	^self section.! !

!PRFlatImporter methodsFor: 'updating' stamp: 'FW 6/18/2005 18:20'!
updateLink: sw2Page page: aParent 
	"PRTreeImporter compatibility"
	! !

!PRFlatImporter methodsFor: 'updating' stamp: 'mim 6/17/2005 13:42'!
updateLinks: aPRPage
	"Change links to absolute links"
	
	| parser |
	
	parser := PRFlatLinkParser on: (ReadStream on: aPRPage contents).
	parser path: (PRPathReference from: self root to: self section), '/'.
	parser parse.
	self editPage: aPRPage contents: parser contents! !

!PRImporter class methodsFor: 'accessing-defaults' stamp: 'mim 6/16/2005 08:18'!
defaultFileSize
	"By default we won't download files that are 
	larger than 200 KByte"
	^204800! !

!PRImporter class methodsFor: 'testing' stamp: 'FW 6/18/2005 18:32'!
isAbstract
	^true.! !

!PRImporter class methodsFor: 'instance creation' stamp: 'FW 6/18/2005 19:28'!
new
	self isAbstract
	  ifTrue: [self error: self name, ' is abstract'].
	^super new.! !

!PRImporter class methodsFor: 'instance creation' stamp: 'FW 6/18/2005 19:29'!
root: aStructure context: aContext
^self new
	initialize;
	root: aStructure;
	context: aContext.
	

! !

!PRImporter methodsFor: 'command' stamp: 'rw 6/14/2005 16:26'!
addPage: aPage parent: aParent
	| command currentContext |
	currentContext := self context goto: aParent.
	command := PRNewPageCommand context: currentContext.
	command subpage: aPage.
	command parent: aParent.
	command execute.
! !

!PRImporter methodsFor: 'private' stamp: 'rw 6/14/2005 16:07'!
assureUrlIsValid: aUrl
	"Top level URL nees to end with /1"
	(aUrl last == $/) ifTrue: [^aUrl, '1'].
	(aUrl last isLetter) ifTrue:  [^aUrl, '/1'].
	(aUrl last isDigit) ifTrue: [^aUrl].! !

!PRImporter methodsFor: 'private' stamp: 'rw 6/7/2005 13:18'!
context
	^context! !

!PRImporter methodsFor: 'accessing' stamp: 'rw 6/7/2005 13:18'!
context: anObject
	context := anObject! !

!PRImporter methodsFor: 'private' stamp: 'rw 6/17/2005 14:16'!
createPage: wikipage parent: aParent url: aUrl
	"Add the new page to the parent structure and to the proxy."
	| oldPage |
	(aParent children isValidChild: wikipage) 
		ifFalse: ["page exists, need an update of the content"
				oldPage := aParent children at: wikipage title.
				"oldPage contents: (wikipage contents)."
				self editPage: oldPage contents: wikipage contents.
				self updateLink: oldPage page: aParent.
				self verbose ifTrue: [Transcript cr; show: 'Update ', wikipage title].
				"return the old page, so it can be used further"
				^oldPage]
		ifTrue: ["add a new page"
				self addPage: wikipage parent: aParent.
				self verbose ifTrue: [Transcript cr; show: 'Add ' , wikipage title ,' From: ' , aUrl].
				^wikipage].! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/18/2005 19:49'!
detectSwikiVersion: startUrl 
	"Identify Swiki type."

	"default-version is 1.3"

	| stream document version |
	version := 13.

	"getting the startpage and analyzing the internal links to decide if version 1.3 or 1.4 has to be used"
	stream := PRConnectionProvider uniqueInstance httpGet: startUrl.
	document := HtmlParser parse: stream.
	document allSubentitiesDo: 
			[:tag | 
			(tag class = HtmlAnchor and: [PRSwiki14Wrapper isInternalLink: tag]) 
				ifTrue: [version := 14]].
	version = 13 
		ifTrue: 
			[self verbose 
				ifTrue: 
					[Transcript
						cr;
						show: 'Importing Swikiversion 1.3'].
			self proxy wrapper: PRSwiki13Wrapper]
		ifFalse: 
			[self verbose 
				ifTrue: 
					[Transcript
						cr;
						show: 'Importing Swikiversion 1.4'].
			self proxy wrapper: PRSwiki14Wrapper
			"add other wrapper"]! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/12/2005 13:08'!
doImport:aUrl
	"I am an hock method doing nothing,sublasses should override me!!"
    ! !

!PRImporter methodsFor: 'command' stamp: 'rw 6/17/2005 16:14'!
editFile: aFile contents: aContent
	| command currentContext |
	currentContext := self context goto: aFile.
	command := PREditFileCommand context: currentContext.
	command contents: aContent.
	command execute.! !

!PRImporter methodsFor: 'command' stamp: 'rw 6/12/2005 14:01'!
editPage: aPage contents: aContent
	| command currentContext |
	currentContext := self context goto: aPage.
	command := PREditPageCommand context: currentContext.
	command contents: aContent.
	command execute.! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/18/2005 11:43'!
endImport
	"I am an hock method. I go through the imported pages and reset the links. My default behavior should normally not been overriden by subclasses"

	| visitor |
	self verbose 
		ifTrue: 
			[Transcript
				cr;
				show: 'Imported all pages, now updating the links...'].
	visitor := PRLinkUpdateVisitor new.
	visitor context: self context.
	visitor start: self startPRPage.
	self verbose 
		ifTrue: 
			[Transcript
				cr;
				show: 'Import finished']! !

!PRImporter methodsFor: 'private' stamp: 'mim 6/16/2005 08:27'!
fileSize
	^fileSize! !

!PRImporter methodsFor: 'accessing' stamp: 'mim 6/16/2005 08:27'!
fileSize: aNumber
	fileSize := aNumber! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/18/2005 20:26'!
importMedia: anUrl page: aParent 
	| file mime provider |
	provider := PRConnectionProvider uniqueInstance.
	file := PRFile new.
	file title: (Url absoluteFromText: anUrl) path last.
     "controls if the media is not to big, the fileSize in converted into bytes"
	(provider contentLength: anUrl) < (self fileSize * 1024)
		ifTrue: 
			["Replace mime type of binary files"

			mime := provider contentType: anUrl.
			mime = 'application/octet-stream' ifTrue: [mime := 'application/binary'].
			file mimetype: mime.
			file contents: (provider httpGetMedia: anUrl)]
		ifFalse: 
			[file contents: 'File was to big'.
			file mimetype: 'text/plain'].
	file filename: file title.
	(aParent children isValidChild: file) 
		ifTrue: 
			[self verbose 
				ifTrue: 
					[Transcript
						cr;
						show: 'Import media: ' , anUrl , '. Parent is ' , aParent title].
			self addPage: file parent: aParent
			"aParent children add: file"]
		ifFalse: 
			[self verbose 
				ifTrue: 
					[Transcript
						cr;
						show: 'Update media: ' , anUrl , '. Parent is ' , aParent title].
			self editFile: file contents: file contents]! !

!PRImporter methodsFor: 'accessing' stamp: 'FW 6/12/2005 13:09'!
importSwikiFromUrl: aUrl
     "This is a template method. subclasses can override the hock methods to do specific tasks"
     
	self doImport: (self prepareImport: aUrl).
	self endImport. ! !

!PRImporter methodsFor: 'initialize-release' stamp: 'mim 6/16/2005 08:26'!
initialize
	fileSize := self class defaultFileSize! !

!PRImporter methodsFor: 'private' stamp: 'rw 6/13/2005 11:26'!
prepareImport:aUrl
	"I am an hock method. I fullfill initialization tasks. My default behavior should normally not been overriden by subclasses"
     |validUrl|
     
	validUrl := self assureUrlIsValid: aUrl.
	self detectSwikiVersion: validUrl.
	^validUrl.! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/18/2005 11:41'!
proxy
	proxy isNil ifTrue: [proxy := PRPageProxy new].
	^proxy! !

!PRImporter methodsFor: 'private' stamp: 'FW 4/20/2005 08:57'!
root
	^root ! !

!PRImporter methodsFor: 'accessing' stamp: 'mim 4/15/2005 16:02'!
root: aStructure
	root := aStructure! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/10/2005 16:20'!
startPRPage
	"I am an hock method and return the starting PRPage of an imported swiki. Subclass can override my default behavior"

	^self root.! !

!PRImporter methodsFor: 'private' stamp: 'FW 6/14/2005 22:43'!
verbose
	"If I return true some log statements will be produced"
	^true.! !

PRImporter subclass: #PRTreeImporter
	instanceVariableNames: 'queue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRTreeImporter commentStamp: '<historical>' prior: 0!
I import the swikis in tree mode, establishing a hierarchy. I use width search.!

!PRTreeImporter class methodsFor: 'testing' stamp: 'FW 6/18/2005 19:29'!
isAbstract
	^false.! !

!PRTreeImporter methodsFor: 'private' stamp: 'rw 6/16/2005 20:10'!
doImport:validUrl
	| pair |

	"I override the hock method of my superclass"

	self queue: OrderedCollection new.
	self importPageFromUrl: validUrl parent: self root.
	[self queue size > 0] whileTrue: [
				pair := self queue removeFirst.
				self importPageFromUrl: (pair at: 1) parent: (pair at: 2).]! !

!PRTreeImporter methodsFor: 'private' stamp: 'rw 6/17/2005 16:18'!
importPageFromUrl: aUrl parent: aParent
	| sw2PageWrapper sw2Page |

	(self proxy includesKey: aUrl)
		ifTrue: [
			"Get access to the existing page"
			sw2PageWrapper := self proxy getPage: aUrl.
			self updateLink: sw2PageWrapper asPRPage page: aParent]
		ifFalse: [
			"Create a new wikipage"
			sw2PageWrapper := self proxy getPage: aUrl. "do not pull out of true-false-block, else includeskey fails"
			sw2Page := sw2PageWrapper asPRPage.
			sw2Page := self createPage: sw2Page parent: aParent url: aUrl.
			sw2PageWrapper sw2page: sw2Page.
			
			"import media files to wiki"
			sw2PageWrapper getAllMedia
				do: [:anUrl | self importMedia: anUrl page: sw2Page].
			
			"Import all referenzed swiki pages."
			sw2PageWrapper getAllInternalLinks
				do: [:anUrl | 
					"self importPageFromUrl: anUrl parent: sw2Page recursive: false."
					self queue addLast: (Array with: anUrl with: sw2Page)].
			
			"Update all anchors in the page"
			self updateAnchors:  sw2Page.
		]! !

!PRTreeImporter methodsFor: 'accessing' stamp: 'rw 6/16/2005 19:38'!
queue
	^queue! !

!PRTreeImporter methodsFor: 'accessing' stamp: 'rw 6/16/2005 19:38'!
queue: anObject
	queue := anObject! !

!PRTreeImporter methodsFor: 'private' stamp: 'mim 6/17/2005 14:03'!
updateAnchors: aPRPage
	"Change links to absolute links"
	
	| parser |
	
	parser := PRLinkParser on: (ReadStream on: aPRPage contents).
	parser parse.
	self editPage: aPRPage contents: parser contents! !

!PRTreeImporter methodsFor: 'private' stamp: 'rw 6/17/2005 14:16'!
updateLink: sw2Page page: aParent 
	"We found a link in the page aParent to a page that allready exists. 
	Since Smallwiki doesn't like links to other branches we need to change  
	the link in the contents"
	
	| contents title path |
	contents := aParent contents.
	title := sw2Page title.
	
	"Path from the root to the page that we actually wanted to add as child"
	[path := PRPathReference from: self root to: sw2Page.] on: Error do: [Transcript show: 'Stupid Link Error'. ^nil].
	
	"Change the swiki link to a absolute url: For links with and without 
	alias (*Page 1* or *alias>Page 1*)"
	contents := contents copyReplaceAll: title , '*' with: path , '*'.
	
	"Add an alias to those links that havent got one (*myalias>Page 1*)"
	contents := contents copyReplaceAll: '*' , path , '*' with: '*' , title , '>' , path , '*'.
	self editPage: aParent contents: contents! !

Object subclass: #PRMockSocket
	instanceVariableNames: ''
	classVariableNames: 'Sites'
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRMockSocket commentStamp: '<historical>' prior: 0!
This is a mock socket. This class will return static pages and pretend
that the pages come from a server.!

!PRMockSocket class methodsFor: 'accessing' stamp: 'mim 6/10/2005 13:59'!
httpGet: aUrl
	| fakeStream |
	
	[fakeStream := Sites at: aUrl asString]
		on: Error
		do: [fakeStream := 'HTTP 404 Site does not exist'].
	^fakeStream! !

!PRMockSocket class methodsFor: 'accessing' stamp: 'mim 4/15/2005 22:35'!
httpGet: aUrl accept: aMime
	^MockSocket httpGet: aUrl! !

!PRMockSocket class methodsFor: 'accessing' stamp: 'mim 4/16/2005 09:01'!
httpGet: aUrl args: args user: aUser passwd: aPassword
	"Simulates an authentication httpGet:"
	^MockSocket httpGet: aUrl! !

!PRMockSocket class methodsFor: 'accessing' stamp: 'FW 4/24/2005 14:26'!
rootPath
	^'http://www.mock.com/mock'! !

PRMockSocket subclass: #PRSwiki13Mock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRSwiki13Mock commentStamp: '<historical>' prior: 0!
I'm a sublcass of PRMockSocket to simulate swikis of version 1.3!

!PRSwiki13Mock class methodsFor: 'as yet unclassified' stamp: 'rw 4/25/2005 15:28'!
initialize
	| stream |
	Sites := Dictionary new.

	" ------------------------------------------------------------------------------------------------------------------------------
	Here we have the html files for a small swiki. The swiki consists of three pages:
	
	mock Swiki
	|-Page 1
	|-Page 2
	
	Here is the important part.
	
	Title: 		mock Swiki
	Url:  		http://www.mock.com/mock/1
	Contents:	<h2>mock Swiki</h2>
				Congratulations!! This is a new Swiki.<br>
				<a href=/mock/2 onmouseover=window.status='last edited 1 minute ago'; return true onmouseout=window.status='' ''; return true>Page 1</a><br>
                   <a href=/mock/3 onmouseover=window.status=''last edited less than 1 minute ago''; return true onmouseout=window.status='' ''; return true>Page 2</a><br>
	
	Title:		Page 1
	Url:			http://www.mock.com/mock/2
	Contents:	<h2>Page 1</h2>
				I am <b>Page 1</b> with no links.
		
	Title:		Page 2
	Url:			http://www.mock.com/mock/3
	Contents:	<h2>Page 2</h2>
				I am Page 2 with no links.<br>
		
	  ------------------------------------------------------------------------------------------------------------------------------"
	
	stream := WriteStream on: (String new).
	stream nextPutAll: '<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
      <html> 
      <head>
      <title>mock Swiki</title>
      <script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script>
      </head>
      <body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
      <script type="text/javascript">
      <!!--
      initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
      //-->
      </script>
      <table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
      <td width=80 valign=top><img src="/schemes/dock/viewie.png" border=0 width=80 height=74 alt="View this Page"><a href="/mock/1.edit" onMouseOver="rollOver(''edit'',           true)" onMouseOut="rollOver(''edit'', false)"><img src="/schemes/dock/edit.png" id="edit" name="edit" border=0 width=80 height=74 alt="Edit this Page"></a><a    
      href="/mock/1.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" 
      name="upload" border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/1.history" onMouseOver="rollOver(''history'', true)"  
      onMouseOut="rollOver(''history'', false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this 
      Page"></a><img src="/schemes/dock/topie.png" border=0 width=80 height=74 alt="Home"><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" 
      onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a 
      href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img src="/schemes/dock/search.png" id="search" 
      name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" onMouseOut="rollOver(''help'', false)">
      <img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top width="100%">
      <h2>mock Swiki</h2>
      Congratulations!! This is a new Swiki.<br>
      <br>
      <a href="/mock/2" onmouseover="window.status=''last edited 1 minute ago''; return true" onmouseout="window.status='' ''; return true">Page 1</a><br>
      <a href="/mock/3" onmouseover="window.status=''last edited less than 1 minute ago''; return true" onmouseout="window.status='' ''; return true">Page 2</a><br>
      </td>
      </tr>
      </table>
      </body>
      </html>'.
		
	Sites at: self rootPath, '/1' put: stream.
		
	"Page 1 has a link to this page: href=/mock/2"
	stream := WriteStream on: (String new).
	stream nextPutAll:
	 '<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
      <html>
      <head>
      <title>Page 1</title>
      <script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script>
      </head>
      <body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
      <script type="text/javascript">
      <!!--
      initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
      //-->
     </script>
    <table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
    <td width=80 valign=top><img src="/schemes/dock/viewie.png" border=0 width=80 height=74 alt="View this Page"><a href="/mock/2.edit" onMouseOver="rollOver(''edit'', true)"
    onMouseOut="rollOver(''edit'', false)"><img src="/schemes/dock/edit.png" id="edit" name="edit" border=0 width=80 height=74 alt="Edit this Page"></a><a href="/mock/2.upload" 
    onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload" border=0 width=80 
    height=74 alt="Uploads to this Page"></a><a href="/mock/2.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', false)"><img 
    src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><a href="/mock" onMouseOver="rollOver(''top'',
    true)" onMouseOut="rollOver(''top'', false)"><img src="/schemes/dock/top.png" id="top" name="top" border=0 width=80 height=74 alt="Home"></a><a href="/mock/recent"
    onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 
    height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img 
    src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" 
    onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top 
    width="100%">
   <h2>Page 1</h2>
   I am <b>Page 1</b> with no links.<br>
   </td>
   </tr></table>
   </body>
   </html>'.
		
	Sites at: self rootPath, '/2' put: stream.
	
	"Page 1 has a link to this page: href=/mock/3"
	stream := WriteStream on: (String new).
	stream nextPutAll:
	 '<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
      <html>
      <head>
      <title>Page 2</title>
      <script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script>
      </head>
      <body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
      <script type="text/javascript">
      <!!--
      initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
      //-->
      </script>
      <table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
      <td width=80 valign=top><img src="/schemes/dock/viewie.png" border=0 width=80 height=74 alt="View this Page"><a href="/mock/3.edit" onMouseOver="rollOver(''edit'',    
      true)" onMouseOut="rollOver(''edit'', false)"><img src="/schemes/dock/edit.png" id="edit" name="edit" border=0 width=80 height=74 alt="Edit this Page"></a><a 
      href="/mock/3.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload"
      border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/3.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', 
      false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><a href="/mock" 
      onMouseOver="rollOver(''top'', true)" onMouseOut="rollOver(''top'', false)"><img src="/schemes/dock/top.png" id="top" name="top" border=0 width=80 height=74 
      alt="Home"></a><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" 
      name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', 
      false)"><img src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'',
      true)" onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td 
      valign=top width="100%">
      <h2>Page 2</h2>
      I am Page 2 with no links.<br>
      </td>
      </tr></table>
      </body>
      </html>'.

	Sites at: self rootPath, '/3' put: stream.
		
	" ------------------------------------------------------------------------------------------------------------------------------
	We also need the .edit version of the three pages.
	 
	mock Swiki
	|-Page 1
	|-Page 2
	
     Here is the important part.
	 
	Title: 		mock Swiki
	Url:  		http://www.mock.com/mock/1.edit
	Contents:	<textarea name=text rows=20 cols=70 wrap=virtual>
				Congratulations!! This is a new Swiki.
				*Page 1*
				*Page 2*
				</textarea>
	
	Title:		Page 1
	Url:			http://www.mock.com/mock/2.edit
	Contents:	<textarea name=text rows=20 cols=70 wrap=virtual>
				I am Page 1 with no links.
				</textarea>
		
	Title:		Page 2
	Url:			http://www.mock.com/mock/3.edit
	Contents:	<textarea name=text rows=20 cols=70 wrap=virtual>
				I am Page 2 with no links.
				</textarea>
	  ------------------------------------------------------------------------------------------------------------------------------"
	
	stream := WriteStream on: (String new).
	stream nextPutAll: 	
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Edit mock Swiki</title>
<script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script>
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
//-->
</script>
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td width=80 valign=top><a href="/mock/1" onMouseOver="rollOver(''view'', true)" onMouseOut="rollOver(''view'', false)"><img src="/schemes/dock/view.png" id="view" name="view" border=0 width=80 height=74 alt="View this Page"></a><img src="/schemes/dock/editie.png" border=0 width=80 height=74 alt="Edit this Page"><a href="/mock/1.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload" border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/1.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><img src="/schemes/dock/topie.png" border=0 width=80 height=74 alt="Home"><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top width="100%">
<form action="/mock/1.save" method=post>
<input type="hidden" value="3291805101" name="edittime">
<h2>Title:&nbsp;&nbsp;<input type="text" size=40 value="mock Swiki" name="name"></h2>
<p>Last edited: 1:43:17 pm on 24 April 2005 by localhost</p>
<textarea name="text" rows=20 cols=70 wrap=virtual>Congratulations!! This is a new Swiki.

*Page 1*
*Page 2*</textarea><br>

<input type="submit" value="save"><br>
<hr size=1 noshade>
<input type="checkbox" name="lock" value="true"> - lock this page<br>
<input type="password" size=10 name="password"> - enter new password<br>
<input type="password" size=10 name="passwordcheck"> - reenter same password<br>
<hr size=1 noshade>
<p>Send e-mail alerts to these addresses upon next save:</p>
<textarea name="alerts" rows=3 cols=70 wrap=virtual></textarea>
</form>
</td>
</tr></table>
</body>
</html>'.

	Sites at: self rootPath, '/1.edit' put: stream.
	
	stream := WriteStream on: (String new).
	stream nextPutAll: 	
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Edit Page 1</title>
<script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script>
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
//-->
</script>
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td width=80 valign=top><a href="/mock/2" onMouseOver="rollOver(''view'', true)" onMouseOut="rollOver(''view'', false)"><img src="/schemes/dock/view.png" id="view" name="view" border=0 width=80 height=74 alt="View this Page"></a><img src="/schemes/dock/editie.png" border=0 width=80 height=74 alt="Edit this Page"><a href="/mock/2.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload" border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/2.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><a href="/mock" onMouseOver="rollOver(''top'', true)" onMouseOut="rollOver(''top'', false)"><img src="/schemes/dock/top.png" id="top" name="top" border=0 width=80 height=74 alt="Home"></a><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top width="100%">
<form action="/mock/2.save" method=post>
<input type="hidden" value="3291805242" name="edittime">
<h2>Title:&nbsp;&nbsp;<input type="text" size=40 value="Page 1" name="name"></h2>
<p>Last edited: 1:43:46 pm on 24 April 2005 by localhost</p>
<textarea name="text" rows=20 cols=70 wrap=virtual>I am &lt;b&gt;Page 1&lt;/b&gt; with no links.</textarea><br>

<input type="submit" value="save"><br>
<hr size=1 noshade>
<input type="checkbox" name="lock" value="true"> - lock this page<br>
<input type="password" size=10 name="password"> - enter new password<br>
<input type="password" size=10 name="passwordcheck"> - reenter same password<br>
<hr size=1 noshade>
<p>Send e-mail alerts to these addresses upon next save:</p>
<textarea name="alerts" rows=3 cols=70 wrap=virtual></textarea>
</form>
</td>
</tr></table>
</body>
</html>'.


	Sites at: self rootPath, '/2.edit' put: stream.
	
	stream := WriteStream on: (String new).
	stream nextPutAll:' 	
		<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Edit Page 2</title>
<script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script>
</head>
<body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
//-->
</script>
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td width=80 valign=top><a href="/mock/3" onMouseOver="rollOver(''view'', true)" onMouseOut="rollOver(''view'', false)"><img src="/schemes/dock/view.png" id="view" name="view" border=0 width=80 height=74 alt="View this Page"></a><img src="/schemes/dock/editie.png" border=0 width=80 height=74 alt="Edit this Page"><a href="/mock/3.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload" border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/3.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><a href="/mock" onMouseOver="rollOver(''top'', true)" onMouseOut="rollOver(''top'', false)"><img src="/schemes/dock/top.png" id="top" name="top" border=0 width=80 height=74 alt="Home"></a><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top width="100%">
<form action="/mock/3.save" method=post>
<input type="hidden" value="3291805308" name="edittime">
<h2>Title:&nbsp;&nbsp;<input type="text" size=40 value="Page 2" name="name"></h2>
<p>Last edited: 1:44:07 pm on 24 April 2005 by localhost</p>
<textarea name="text" rows=20 cols=70 wrap=virtual>I am Page 2 with no links.</textarea><br>

<input type="submit" value="save"><br>
<hr size=1 noshade>
<input type="checkbox" name="lock" value="true"> - lock this page<br>
<input type="password" size=10 name="password"> - enter new password<br>
<input type="password" size=10 name="passwordcheck"> - reenter same password<br>
<hr size=1 noshade>
<p>Send e-mail alerts to these addresses upon next save:</p>
<textarea name="alerts" rows=3 cols=70 wrap=virtual></textarea>
</form>
</td>
</tr></table>
</body>
</html>'.


	Sites at: self rootPath, '/3.edit' put: stream.
		
	"------------------------------------------------------------------------------------------------------------------------------
	If a page is protected by a security realm, the HTTPSocket returns the following string.
	I got the response from: http://scgwiki.iam.unibe.ch:8080/SmalltalkWiki/1.edit
      ------------------------------------------------------------------------------------------------------------------------------"
	
	Sites at: self rootPath, '/401' put:
		'HTTP/1.1 401 Unauthorized
		Server: Comanche/kom-4.10
		Cache-Control: no-cache
		WWW-Authenticate: Basic realm="/SmalltalkWiki/*"
		Pragma: no-cache
		Connection: Keep-Alive
		Expires: 0
		Content-type: text/plain
		Content-length: 34Unauthorized for: /SmalltalkWiki/*' withBlanksCondensed.

! !

PRMockSocket subclass: #PRSwiki14Mock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRSwiki14Mock commentStamp: '<historical>' prior: 0!
I'm a sublcass of PRMockSocket to simulate swikis of version 1.4!

!PRSwiki14Mock class methodsFor: 'as yet unclassified' stamp: 'rw 4/25/2005 15:28'!
initialize
	| stream |
	Sites := Dictionary new.

	" ------------------------------------------------------------------------------------------------------------------------------
	Here we have the html files for a small swiki. The swiki consists of three pages:
	
	mock Swiki
	|-Page 1
	|-Page 2
	
	Here is the important part.
	
	Title: 		mock Swiki
	Url:  		http://www.mock.ch/mock/1
	Contents:	<h2>mock Swiki</h2>
				Congratulations!! This is a new Swiki.<br>
				<a class=internal href=/mock/2 title=Page 1: last edited 2 hours ago by localhost>Page 1</a><br>
				<a class=internal href=/mock/3 title=Page 2: last edited 2 hours ago by localhost>Page 2</a><br>
	
	Title:		Page 1
	Url:			http://www.mock.ch/mock/2
	Contents:	<h2>Page 1</h2>
				I am Page 1 with no links.
		
	Title:		Page 2
	Url:			http://www.mock.ch/mock/3
	Contents:	<h2>Page 2</h2>
				I am Page 2 with no links.<br>
		
	  ------------------------------------------------------------------------------------------------------------------------------"
	
	stream := WriteStream on: (String new).
	stream nextPutAll: 	
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
		<html><head>	<title>mock Swiki</title>
		<link rel="shortcut icon" href="/schemes/poor/favicon.ico">
		<link rel=stylesheet href="/schemes/poor/style.css" type="text/css">
		</head>
		<body bgcolor="#ffffff" text="#000000" link="#3300cc" alink="#cc0033" vlink="#550088">
		<img src="/schemes/poor/viewie.gif" border=0 width=56 height=17 alt="View this Page"><a href="/mock/1.edit" title="Edit this Page"><img 		src="/schemes/poor/edit.gif" border=0 width=49 height=17 alt="Edit this Page"></a><a href="/mock/1.upload" title="Attachments to this 		Page"><img src="/schemes/poor/upload.gif" border=0 width=62 height=17 alt="Attachments to this Page"></a><a href="/mock/1.history" 		title="History of this Page"><img src="/schemes/poor/history.gif" border=0 width=70 height=17 alt="History of this Page"></a><img 		src="/schemes/poor/topie.gif" border=0 width=59 height=17 alt="Home"><a href="/mock/recent" title="Recent Changes"><img 		src="/schemes/poor/recent.gif" border=0 width=76 height=17 alt="Recent Changes"></a><a href="/mock/search" title="Search the Swiki"><img 		src="/schemes/poor/search.gif" border=0 width=67 height=17 alt="Search the Swiki"></a><a href="/mock/help" title="Help Guide"><img 		src="/schemes/poor/help.gif" border=0 width=48 height=17 alt="Help Guide"></a>
		<h2>mock Swiki</h2>
		Congratulations!! This is a new Swiki.<br>
		<a class="internal" href="/mock/2" title="Page 1: last edited 2 hours ago by localhost">Page 1</a><br>
		<a class="internal" href="/mock/3" title="Page 2: last edited 2 hours ago by localhost">Page 2</a><br>
		</body></html>'.
	Sites at: self rootPath, '/1' put: stream.
		
	"Page 1 has a link to this page: href=/mock/2"
	stream := WriteStream on: (String new).
	stream nextPutAll:
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
		<html><head><title>Page 1</title>
		<link rel="shortcut icon" href="/schemes/poor/favicon.ico">
		<link rel=stylesheet href="/schemes/poor/style.css" type="text/css">
		</head>
		<body bgcolor="#ffffff" text="#000000" link="#3300cc" alink="#cc0033" vlink="#550088">
		<img src="/schemes/poor/viewie.gif" border=0 width=56 height=17 alt="View this Page"><a href="/mock/2.edit" title="Edit this Page"><img 		src="/schemes/poor/edit.gif" border=0 width=49 height=17 alt="Edit this Page"></a><a href="/mock/2.upload" title="Attachments to this Page"><img 		src="/schemes/poor/upload.gif" border=0 width=62 height=17 alt="Attachments to this Page"></a><a href="/mock/2.history" title="History of this 		Page"><img src="/schemes/poor/history.gif" border=0 width=70 height=17 alt="History of this Page"></a><a href="/mock" title="Home"><img 		src="/schemes/poor/top.gif" border=0 width=59 height=17 alt="Home"></a><a href="/mock/recent" title="Recent Changes"><img 		src="/schemes/poor/recent.gif" border=0 width=76 height=17 alt="Recent Changes"></a><a href="/mock/search" title="Search the Swiki"><img 		src="/schemes/poor/search.gif" border=0 width=67 height=17 alt="Search the Swiki"></a><a href="/mock/help" title="Help Guide"><img 		src="/schemes/poor/help.gif" border=0 width=48 height=17 alt="Help Guide"></a>
		<h2>Page 1</h2>
		I am Page 1 with no links.<br>
		</body></html>'.
	Sites at: self rootPath, '/2' put: stream.
	
	"Page 1 has a link to this page: href=/mock/3"
	stream := WriteStream on: (String new).
	stream nextPutAll:
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
		<html><head><title>Page 1</title>
		<link rel="shortcut icon" href="/schemes/poor/favicon.ico">
		<link rel=stylesheet href="/schemes/poor/style.css" type="text/css">
		</head>
		<body bgcolor="#ffffff" text="#000000" link="#3300cc" alink="#cc0033" vlink="#550088">
		<img src="/schemes/poor/viewie.gif" border=0 width=56 height=17 alt="View this Page"><a href="/mock/2.edit" title="Edit this Page"><img 		src="/schemes/poor/edit.gif" border=0 width=49 height=17 alt="Edit this Page"></a><a href="/mock/2.upload" title="Attachments to this Page"><img 		src="/schemes/poor/upload.gif" border=0 width=62 height=17 alt="Attachments to this Page"></a><a href="/mock/2.history" title="History of this 		Page"><img src="/schemes/poor/history.gif" border=0 width=70 height=17 alt="History of this Page"></a><a href="/mock" title="Home"><img 		src="/schemes/poor/top.gif" border=0 width=59 height=17 alt="Home"></a><a href="/mock/recent" title="Recent Changes"><img 		src="/schemes/poor/recent.gif" border=0 width=76 height=17 alt="Recent Changes"></a><a href="/mock/search" title="Search the Swiki"><img 		src="/schemes/poor/search.gif" border=0 width=67 height=17 alt="Search the Swiki"></a><a href="/mock/help" title="Help Guide"><img 		src="/schemes/poor/help.gif" border=0 width=48 height=17 alt="Help Guide"></a>
		<h2>Page 2</h2>
		I am Page 2 with no links.<br>
		</body></html>'.
	Sites at: self rootPath, '/3' put: stream.
		
	" ------------------------------------------------------------------------------------------------------------------------------
	We also need the .edit version of the three pages.
	 
	mock Swiki
	|-Page 1
	|-Page 2
	
     Here is the important part.
	 
	Title: 		mock Swiki
	Url:  		http://www.mock.ch/mock/1.edit
	Contents:	<textarea name=text rows=20 cols=70 wrap=virtual>
				Congratulations!! This is a new Swiki.
				*Page 1*
				*Page 2*
				</textarea>
	
	Title:		Page 1
	Url:			http://www.mock.ch/mock/2.edit
	Contents:	<textarea name=text rows=20 cols=70 wrap=virtual>
				I am Page 1 with no links.
				</textarea>
		
	Title:		Page 2
	Url:			http://www.mock.ch/mock/3.edit
	Contents:	<textarea name=text rows=20 cols=70 wrap=virtual>
				I am Page 2 with no links.
				</textarea>
	  ------------------------------------------------------------------------------------------------------------------------------"
	
	stream := WriteStream on: (String new).
	stream nextPutAll: 	
		'<!!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"><html><head><meta content="HTML Tidy for Windows (vers 1st February 2003), see www.w3.org" 		name="generator"><title>Edit mock Swiki</title><meta name="robots" content="noarchive"><link rel="shortcut icon" href="/schemes/poor/favicon.ico"><link rel="stylesheet" 		href="/schemes/poor/style.css" type="text/css"></head><body bgcolor="#ffffff" text="#000000" link="#3300CC" alink="#CC0033" vlink="#550088">
		<a href="/mock/1" title="View this Page"><img src="/schemes/poor/view.gif" border="0" width="56" height="17" alt="View this Page"></a><img   src="/schemes/poor/editie.gif" 		border="0" width="49" height="17" alt="Edit this Page"><a href="/mock/1.upload" title="Attachments to this Page"><img   src="/schemes/poor/upload.gif" border="0" width="62" 		height="17" alt="Attachments to this Page"></a><a href="/mock/1.history" title="History of this   Page"><img src="/schemes/poor/history.gif" border="0" width="70" height="17" 		alt="History of this Page"></a><img src="/schemes/poor/topie.gif"   border="0" width="59" height="17" alt="Home"><a href="/mock/recent" title="Recent Changes"><img 		src="/schemes/poor/recent.gif" border="0" width="76"   height="17" alt="Recent Changes"></a><a href="/mock/search" title="Search the Swiki"><img 		src="/schemes/poor/search.gif" border="0" width="67"   height="17" alt="Search the Swiki"></a><a href="/mock/help" title="Help Guide"><img src="/schemes/poor/help.gif" 		border="0" width="48" height="17"   alt="Help Guide"></a>
		<form action="/mock/1.save" method="post"><input type="hidden" value="3291064149" name="edittime"><h2>Title:&nbsp;&nbsp;<input type="text" size="40" value="mock Swiki" 		name="name"></h2> <small>Last edited: 9:08 pm on 15 April 2005 by localhost</small><br>
 		<textarea name="text" rows="20" cols="70" wrap="virtual">
		Congratulations!! This is a new Swiki.
		*Page 1*
		*Page 2*
		</textarea>
		<br><table border="0" cellpadding="2" cellspacing="0" class="hints"><tr> <td><small>!!heading<br> -bulleted<br> -list<br> #numbered<br> #list</small></td> <td><small>*<u>link to an 		internal page</u>*<br> *<u>http://www.externalSite.com/</u>*<br> *+<u>linkToAnUpload.jpeg</u>+*<br> + ("add to the page" field)<br> _ (horizontal bar)</small></td> 		<td><small>&lt;b&gt;<b>bold</b>&lt;/b&gt;<br> &lt;i&gt;<i>italics</i>&lt;/i&gt;<br> &lt;u&gt;<u>underline</u>&lt;/u&gt;<br> &lt;code&gt;<tt>programming code</tt>&lt;/code&gt;<br> 		&lt;html&gt;imported HTML&lt;/html&gt;</small></td> <td><small>&amp;star; = *<br> &amp;amp; = &amp;<br> &amp;lt; = &lt;<br> &amp;gt; = &gt;<br> <a href="/mock/help#editing" 		target="_new">more...</a></small></td></tr></table> <input type="submit" value="save"><br><hr size="1" noshade> <input type="radio" name="lock" value="unlocked" 		onclick="this.form.password.disabled=true" checked>&nbsp;&nbsp;unlocked   (<em>default</em>)&nbsp;&nbsp;&nbsp;<br>
		<input type="radio" name="lock" value="locked" onclick="this.form.password.disabled=false">&nbsp;&nbsp;lock page by   password&nbsp;&nbsp;&nbsp;<br> <input type="radio" 		name="lock" value="open" onclick="this.form.password.disabled=false">&nbsp;&nbsp;prevent page from being   locked&nbsp;&nbsp;&nbsp;<br> <input type="text" size="10" 		name="password" disabled>&nbsp;&nbsp;enter new password<br><hr size="1" noshade> Send e-mail alerts to these addresses upon next save:<br>
 		<textarea name="alerts" rows="3" cols="70" wrap="virtual">
		</textarea></form>
		</body></html>'.
	Sites at: self rootPath, '/1.edit' put: stream.
	
	stream := WriteStream on: (String new).
	stream nextPutAll: 	
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html><head><meta content="HTML Tidy 		for Windows (vers 1st February 2003), see www.w3.org" name="generator"><title>Edit Page 1</title><meta name="robots" content="noarchive"><link 		rel="shortcut icon" href="/schemes/poor/favicon.ico"><link rel="stylesheet" href="/schemes/poor/style.css" type="text/css"></head><body 		bgcolor="#ffffff" text="#000000" link="#3300CC" alink="#CC0033" vlink="#550088">
		<a href="/mock/2" title="View this Page"><img src="/schemes/poor/view.gif" border="0" width="56" height="17" alt="View this Page"></a><img 		src="/schemes/poor/editie.gif" border="0" width="49" height="17" alt="Edit this Page"><a href="/mock/2.upload" title="Attachments to this Page"><img 		src="/schemes/poor/upload.gif" border="0" width="62" height="17" alt="Attachments to this Page"></a><a href="/mock/2.history" title="History of this 		Page"><img src="/schemes/poor/history.gif" border="0" width="70" height="17" alt="History of this Page"></a><a href="/mock" title="Home"><img 		src="/schemes/poor/top.gif" border="0" width="59" height="17" alt="Home"></a><a href="/mock/recent" title="Recent Changes"><img 		src="/schemes/poor/recent.gif" border="0" width="76" height="17" alt="Recent Changes"></a><a href="/mock/search" title="Search the Swiki"><img 		src="/schemes/poor/search.gif" border="0" width="67" height="17" alt="Search the Swiki"></a><a href="/mock/help" title="Help Guide"><img 		src="/schemes/poor/help.gif" border="0" width="48" height="17" alt="Help Guide"></a>
		<form action="/mock/2.save" method="post"><input type="hidden" value="3291064953" name="edittime"><h2>Title:&nbsp;&nbsp;<input type="text" size="40" 		value="Page 1" name="name"></h2> <small>Last edited: 12:28 am on 16 April 2005 by localhost</small><br>
		<textarea name="text" rows="20" cols="70" wrap="virtual">
		I am Page 1 with no links.
		</textarea>
		<br><table border="0" cellpadding="2" cellspacing="0" class="hints"><tr> <td><small>!!heading<br> -bulleted<br> -list<br> #numbered<br> #list</small></td> 		<td><small>*<u>link to an internal page</u>*<br> *<u>http://www.externalSite.com/</u>*<br> *+<u>linkToAnUpload.jpeg</u>+*<br> + ("add to the page" 		field)<br> _ (horizontal bar)</small></td> <td><small>&lt;b&gt;<b>bold</b>&lt;/b&gt;<br> &lt;i&gt;<i>italics</i>&lt;/i&gt;<br> 		&lt;u&gt;<u>underline</u>&lt;/u&gt;<br> &lt;code&gt;<tt>programming code</tt>&lt;/code&gt;<br> &lt;html&gt;imported HTML&lt;/html&gt;</small></td> 		<td><small>&amp;star; = *<br> &amp;amp; = &amp;<br> &amp;lt; = &lt;<br> &amp;gt; = &gt;<br> <a href="/mock/help#editing" 		target="_new">more...</a></small></td></tr></table> <input type="submit" value="save"><br><hr size="1" noshade> <input type="radio" name="lock" 		value="unlocked" onclick="this.form.password.disabled=true" checked>&nbsp;&nbsp;unlocked (<em>default</em>)&nbsp;&nbsp;&nbsp;<br>
		<input type="radio" name="lock" value="locked" onclick="this.form.password.disabled=false">&nbsp;&nbsp;lock page by 		password&nbsp;&nbsp;&nbsp;<br> <input type="radio" name="lock" value="open" onclick="this.form.password.disabled=false">&nbsp;&nbsp;prevent 		page from being locked&nbsp;&nbsp;&nbsp;<br> <input type="text" size="10" name="password" disabled>&nbsp;&nbsp;enter new password<br><hr 		size="1" noshade> Send e-mail alerts to these addresses upon next save:<br>
		<textarea name="alerts" rows="3" cols="70" wrap="virtual">
		</textarea></form>
		</body></html>'.
	Sites at: self rootPath, '/2.edit' put: stream.
	
	stream := WriteStream on: (String new).
	stream nextPutAll: 	
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html><head><title>Edit Page 2</title><meta 		name="robots" content="noarchive"><link rel="shortcut icon" href="/schemes/poor/favicon.ico"><link rel=stylesheet href="/schemes/poor/style.css" 		type="text/css"></head><body bgcolor="#ffffff" text="#000000" link="#3300cc" alink="#cc0033" vlink="#550088">
		<a href="/mock/3" title="View this Page"><img src="/schemes/poor/view.gif" border=0 width=56 height=17 alt="View this Page"></a><img 		src="/schemes/poor/editie.gif" border=0 width=49 height=17 alt="Edit this Page"><a href="/mock/3.upload" title="Attachments to this Page"><img 		src="/schemes/poor/upload.gif" border=0 width=62 height=17 alt="Attachments to this Page"></a><a href="/mock/3.history" title="History of this 		Page"><img src="/schemes/poor/history.gif" border=0 width=70 height=17 alt="History of this Page"></a><a href="/mock" title="Home"><img 		src="/schemes/poor/top.gif" border=0 width=59 height=17 alt="Home"></a><a href="/mock/recent" title="Recent Changes"><img 		src="/schemes/poor/recent.gif" border=0 width=76 height=17 alt="Recent Changes"></a><a href="/mock/search" title="Search the Swiki"><img 		src="/schemes/poor/search.gif" border=0 width=67 height=17 alt="Search the Swiki"></a><a href="/mock/help" title="Help Guide"><img 		src="/schemes/poor/help.gif" border=0 width=48 height=17 alt="Help Guide"></a>
		<form action="/mock/3.save" method=post> <input type="hidden" value="3291065133" name="edittime"><h2>Title:&nbsp;&nbsp;<input type="text" size=40 		value="Page 2" name="name"></h2> <small>Last edited: 12:28 am on 16 April 2005 by localhost</small><br> <textarea name="text" rows=20 cols=70 		wrap=virtual>I am Page 2 with no links.</textarea><br><table border=0 cellpadding=2 cellspacing=0 class="hints"><tr><td><small> !!heading<br> 		-bulleted<br> -list<br> #numbered<br> #list</small></td> <td><small> *<u>link to an internal page</u>*<br> *<u>http://www.externalSite.com/</u>*<br> 		*+<u>linkToAnUpload.jpeg</u>+*<br> + ("add to the page" field)<br> _ (horizontal bar)</small></td> <td><small> &lt;b&gt;<b>bold</b>&lt;/b&gt;<br> 		&lt;i&gt;<i>italics</i>&lt;/i&gt;<br> &lt;u&gt;<u>underline</u>&lt;/u&gt;<br> &lt;code&gt;<tt>programming code</tt>&lt;/code&gt;<br> &lt;html&gt;imported 		HTML&lt;/html&gt;</small></td> <td><small> &amp;star; = *<br> &amp;amp; = &amp;<br> &amp;lt; = &lt;<br> &amp;gt; = &gt;<br>
		<a href="/mock/help#editing" target="_new">more...</a></small></td></tr></table> <input type="submit" value="save"><br><hr size=1 noshade> <input 		type="radio" name="lock" value="unlocked" onClick="this.form.password.disabled=true" checked>&nbsp;&nbsp;unlocked 		(<em>default</em>)&nbsp;&nbsp;&nbsp;<br> <input type="radio" name="lock" value="locked" 		onClick="this.form.password.disabled=false">&nbsp;&nbsp;lock page 		by 		password&nbsp;&nbsp;&nbsp;<br> <input type="radio" name="lock" 		value="open" onClick="this.form.password.disabled=false">&nbsp;&nbsp;prevent 		page from being 		locked&nbsp;&nbsp;&nbsp;<br> <input type="text" 		size=10 name="password" disabled>&nbsp;&nbsp;enter new password<br><hr size=1 		noshade> Send e-mail alerts to these 		addresses upon next save:<br> 		<textarea name="alerts" rows=3 cols=70 		wrap=virtual></textarea></form></body></html>'.
	Sites at: self rootPath, '/3.edit' put: stream.
		
	"------------------------------------------------------------------------------------------------------------------------------
	If a page is protected by a security realm, the HTTPSocket returns the following string.
	I got the response from: http://scgwiki.iam.unibe.ch:8080/SmalltalkWiki/1.edit
      ------------------------------------------------------------------------------------------------------------------------------"
	
	Sites at: self rootPath, '/401' put:
		'HTTP/1.1 401 Unauthorized
		Server: Comanche/kom-4.10
		Cache-Control: no-cache
		WWW-Authenticate: Basic realm="/SmalltalkWiki/*"
		Pragma: no-cache
		Connection: Keep-Alive
		Expires: 0
		Content-type: text/plain
		Content-length: 34Unauthorized for: /SmalltalkWiki/*' withBlanksCondensed.

	
	"------------------------------------------------------------------------------------------------------------------------------
	This page is used for the SwikiPageWrapper tests
	------------------------------------------------------------------------------------------------------------------------------"
	
	stream := WriteStream on: (String new).
	stream nextPutAll:
		'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html><head><title>Edit mock Swiki</title><script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script></head><body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
//-->
</script>
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td width=80 valign=top><a href="/mock/1" onMouseOver="rollOver(''view'', true)" onMouseOut="rollOver(''view'', false)"><img src="/schemes/dock/view.png" id="view" name="view" border=0 width=80 height=74 alt="View this Page"></a><img src="/schemes/dock/editie.png" border=0 width=80 height=74 alt="Edit this Page"><a href="/mock/1.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload" border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/1.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><img src="/schemes/dock/topie.png" border=0 width=80 height=74 alt="Home"><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top width="100%">
<form action="/mock/1.save" method=post> <input type="hidden" value="3291634982" name="edittime"><h2>Title:&nbsp;&nbsp;<input type="text" size=40 value="mock Swiki" name="name"></h2><p>Last edited: 10:57:09 am on 22 April 2005 by localhost</p>
<textarea name="text" rows=20 cols=70 wrap=virtual>Congratulations!! This is a new Swiki.
*mock Swiki*
*testtest*

*+itouch crash info.txt+*</textarea><br>
<input type="submit" value="save"><br><hr size=1 noshade> <input type="checkbox" name="lock" value="true"> - lock this page<br> <input type="password" size=10 name="password"> - enter new password<br> <input type="password" size=10 name="passwordcheck"> - reenter same password<br><hr size=1 noshade><p>Send e-mail alerts to these addresses upon next save:</p> <textarea name="alerts" rows=3 cols=70 wrap=virtual></textarea></form></td></tr></table></body></html>'.

	Sites at: self rootPath, '/swikipagewrapper.edit' put: stream.


	stream := WriteStream on: (String new).
	stream nextPutAll:
	'<!!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"><html><head><title>mock Swiki</title><script type="text/javascript" src="/schemes/dock/scripts.js" charset="ISO-8859-1"></script></head><body bgcolor="#ffffff" text="#000000" link="#0000cc" alink="#ff0000" vlink="#551a8b" leftmargin=8 topmargin=8 background="/schemes/dock/background.png">
<script type="text/javascript">
<!!--
initRollOver(new Array("view", "edit", "editlock", "upload", "history", "top", "recent", "search", "help"), "/schemes/dock/");
//-->
</script>
<table border=0 cellspacing=0 cellpadding=0 width="100%"><tr>
<td width=80 valign=top><img src="/schemes/dock/viewie.png" border=0 width=80 height=74 alt="View this Page"><a href="/mock/1.edit" onMouseOver="rollOver(''edit'', true)" onMouseOut="rollOver(''edit'', false)"><img src="/schemes/dock/edit.png" id="edit" name="edit" border=0 width=80 height=74 alt="Edit this Page"></a><a href="/mock/1.upload" onMouseOver="rollOver(''upload'', true)" onMouseOut="rollOver(''upload'', false)"><img src="/schemes/dock/upload.png" id="upload" name="upload" border=0 width=80 height=74 alt="Uploads to this Page"></a><a href="/mock/1.history" onMouseOver="rollOver(''history'', true)" onMouseOut="rollOver(''history'', false)"><img src="/schemes/dock/history.png" id="history" name="history" border=0 width=80 height=74 alt="Versions of this Page"></a><img src="/schemes/dock/topie.png" border=0 width=80 height=74 alt="Home"><a href="/mock/recent" onMouseOver="rollOver(''recent'', true)" onMouseOut="rollOver(''recent'', false)"><img src="/schemes/dock/recent.png" id="recent" name="recent" border=0 width=80 height=74 alt="Recent Changes"></a><a href="/mock/search" onMouseOver="rollOver(''search'', true)" onMouseOut="rollOver(''search'', false)"><img src="/schemes/dock/search.png" id="search" name="search" border=0 width=80 height=74 alt="Search"></a><a href="/mock/help" onMouseOver="rollOver(''help'', true)" onMouseOut="rollOver(''help'', false)"><img src="/schemes/dock/help.png" id="help" name="help" border=0 width=80 height=74 alt="Help Guide"></a></td><td valign=top width="100%">
<h2>mock Swiki</h2> Congratulations!! This is a new Swiki.<br> <a href="/mock/1" onmouseover="window.status=''last edited 3 hours ago''; return true" onmouseout="window.status='' ''; return true">mock Swiki</a><br> <a href="/mock/2" onmouseover="window.status=''last edited 3 days ago''; return true" onmouseout="window.status='' ''; return true">testtest</a><br> <br> <a href="/mock/uploads/1/itouch_crash_info.txt">itouch crash info.txt</a><br><hr size=1 noshade><h3>Link to this Page</h3><ul><li><a href="/mock/3">hallo</a> last edited on 19 April 2005 at 8:02:11 pm by localhost</ul></td></tr></table></body></html>
'.

	Sites at: self rootPath, '/swikipagewrapper' put: stream.
! !

Object subclass: #PRPageProxy
	instanceVariableNames: 'pages wrapper'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRPageProxy commentStamp: '<historical>' prior: 0!
We use this proxy to manage wrappers. Every Pier wrapper should only be created once.
We use the url of a swiki page as the key in the dictionary.!

!PRPageProxy methodsFor: 'accessing' stamp: 'mim 4/24/2005 22:06'!
at: url put: anObject
	self pages at: url put: anObject! !

!PRPageProxy methodsFor: 'accessing' stamp: 'rw 4/25/2005 21:49'!
getPage: url
	(self includesKey: url)
		ifFalse: [self pages at: url put: (wrapper url: url)].

	"Return the swiki page. Singelton"
	^self pages at: url! !

!PRPageProxy methodsFor: 'accessing' stamp: 'mim 4/24/2005 22:06'!
includesKey: url
	^self pages includesKey: url! !

!PRPageProxy methodsFor: 'initialize-release' stamp: 'FW 6/18/2005 11:42'!
initialize
	self wrapper: PRSwiki13Wrapper.
	self pages: Dictionary new! !

!PRPageProxy methodsFor: 'private' stamp: 'FW 4/23/2005 10:22'!
pages
	^pages.! !

!PRPageProxy methodsFor: 'private' stamp: 'FW 4/23/2005 10:24'!
pages: aDictionnary
	pages := aDictionnary.! !

!PRPageProxy methodsFor: 'accessing' stamp: 'rw 4/25/2005 21:47'!
wrapper
	^wrapper! !

!PRPageProxy methodsFor: 'accessing' stamp: 'rw 4/25/2005 21:47'!
wrapper: anObject
	wrapper := anObject! !

Object subclass: #PRSwikiPageWrapper
	instanceVariableNames: 'url sw2page parsedHtmlPage parsedEditPage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRSwikiPageWrapper commentStamp: '<historical>' prior: 0!
I am a wrapper for a swiki-page. !

PRSwikiPageWrapper subclass: #PRSwiki13Wrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRSwiki13Wrapper commentStamp: '<historical>' prior: 0!
I'm a sublcass of PRSwikiPageWrapper for swikis of version 1.3!

!PRSwiki13Wrapper class methodsFor: 'testing' stamp: 'mim 6/10/2005 10:13'!
isInternalLink: aTag
	"Definition of an internal link in a Swiki (Version 1.3) page."
	
	| href onmouseover |
	
	href := (aTag getAttribute: 'href') asString.
	onmouseover := (aTag getAttribute: 'onmouseover') asString.
	 
	^(href notEmpty) and: [href first = '/' asCharacter] and: 
	 [onmouseover size >= 13] and: [(onmouseover copyFrom: 1 to: 13) = 'window.status']. ! !

PRSwikiPageWrapper subclass: #PRSwiki14Wrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRSwiki14Wrapper commentStamp: '<historical>' prior: 0!
I'm a sublcass of PRSwikiPageWrapper for swikis of version 1.4!

!PRSwiki14Wrapper class methodsFor: 'testing' stamp: 'FW 4/30/2005 10:39'!
isInternalLink: aTag
	| href class |
	
	href := (aTag getAttribute: 'href') asString.
	class := (aTag getAttribute: 'class') asString.
	 
	^(href notEmpty) and: [class = 'internal'].! !

!PRSwikiPageWrapper class methodsFor: 'testing' stamp: 'mim 6/10/2005 10:20'!
isInternalLink: aTag
	self subclassResponsibility! !

!PRSwikiPageWrapper class methodsFor: 'instance creation' stamp: 'rw 4/25/2005 21:26'!
url: aUrl
	^(self basicNew url: aUrl) initialize! !

!PRSwikiPageWrapper methodsFor: 'comparing' stamp: 'rw 4/25/2005 21:28'!
= aSwikiPage
^ (aSwikiPage class = self class) and: [self title = aSwikiPage title] ! !

!PRSwikiPageWrapper methodsFor: 'conversion' stamp: 'mim 4/22/2005 15:42'!
asPRPage
	^sw2page! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 6/16/2005 14:49'!
getAllInternalLinks
	"Extracts all internal links from this swiki page"
	
	| links |
	
	"Here we save the links."
	links := OrderedCollection new.

	"Search for internal links in the page."
	self parsedHtmlPage allSubentitiesDo:
		[:tag | (tag class = HtmlAnchor) & (self class isInternalLink: tag )
			ifTrue: [ links add: (self stripUrl: (tag getAttribute: 'href')) asString]].
			
	"Return collection that contains all internal urls, as string"
	^links! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'FW 6/12/2005 14:11'!
getAllMedia
	"Extracts all media links from this swiki page"
	
	| links mediaUrl |
	
	"Here we save the links."
	links := OrderedCollection new.

	"images"
	self parsedHtmlPage allSubentitiesDo:
		[:tag | (tag class = HtmlImage) ifTrue: 
			[ mediaUrl := ((Url absoluteFromText: self url) newFromRelativeText: (tag getAttribute: 'src')) asString.
			(('*', self uploadDir, '*') match: mediaUrl) ifTrue: [links add: mediaUrl]]
		].
			
	"other data"
	self parsedHtmlPage allSubentitiesDo:
		[:tag | ((tag class = HtmlAnchor) and:[(tag getAttribute:'href') isNil not]) ifTrue: 
			[ mediaUrl := ((Url absoluteFromText: self url) newFromRelativeText: (tag getAttribute: 'href')) asString.
			(('*', self uploadDir, '*') match: mediaUrl) ifTrue: [links add: mediaUrl]]
		].
	
	"Return collection that contains all internal urls, as string"
	^links! !

!PRSwikiPageWrapper methodsFor: 'comparing' stamp: 'mim 4/22/2005 15:24'!
hash
	^self title hash! !

!PRSwikiPageWrapper methodsFor: 'comparing' stamp: 'FW 6/18/2005 11:43'!
initialize
	"Load and store the swikipage"

	| stream |
	stream := PRConnectionProvider uniqueInstance httpGet: self url.
	parsedHtmlPage := HtmlParser parse: stream.

	"Get the edit-page of the swikipage and transform it to a smallwiki2page"
	stream := PRConnectionProvider uniqueInstance htmlProvider 
				httpGet: self url , '.edit'.
	(PRConnectionProvider uniqueInstance isLocked: stream) 
		ifTrue: 
			[Transcript
				cr;
				show: 'Error: ' , self url , ' is locked'.
			self parseLockedPage: parsedHtmlPage]
		ifFalse: 
			[parsedEditPage := HtmlParser parse: stream.
			self parsePRPage: parsedEditPage]! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'rw 6/13/2005 11:23'!
parseLockedPage: aParsedHtmlPage 
	| title contents |
	title := self url.
	contents := 'locked'.

	"Extract the title of the page"
	aParsedHtmlPage allSubentitiesDo: 
			[:tag | 
			tag class = HtmlTitle 
				ifTrue: [title := tag textualContents asString]].

	"Extract body from old swiki."
	aParsedHtmlPage allSubentitiesDo: 
			[:tag | 
			tag class = HtmlBody
				ifTrue: [contents := tag textualContents asString]].

	"Create a smallwiki page."
	sw2page := PRPage title: title.
	sw2page contents: contents! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'rw 6/13/2005 11:25'!
parsePRPage: aParsedEditPage 
	| title contents |
	title := self url.
	contents := 'parse'.

	"Extract the title of the page"
	aParsedEditPage allSubentitiesDo: 
			[:tag | 
			tag class = HtmlInput & ((tag getAttribute: 'name') = 'name') 
				ifTrue: [title := (tag getAttribute: 'value') asString.]].

	"Extract textarea from old swiki."
	aParsedEditPage allSubentitiesDo: 
			[:tag | 
			tag class = HtmlTextArea & ((tag getAttribute: 'name') = 'text') 
				ifTrue: [contents := tag textualContents asString]].

	"Create a smallwiki page."
	sw2page := PRPage title: title.
	sw2page contents: contents.! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 6/10/2005 10:10'!
parsedEditPage
	^parsedEditPage! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 6/10/2005 10:11'!
parsedHtmlPage
	^parsedHtmlPage! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 6/16/2005 14:48'!
stripUrl: path
	"Remove anchors and stuff like that"
	
	| strippedUrl |
	strippedUrl := (Url absoluteFromText: (self url)) newFromRelativeText: path.
	strippedUrl := strippedUrl withoutFragment. 
	
	^strippedUrl! !

!PRSwikiPageWrapper methodsFor: 'accessing' stamp: 'FW 4/23/2005 10:14'!
sw2page
	
	^sw2page ! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 6/10/2005 10:09'!
sw2page: aPRpage.
	sw2page := aPRpage.! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 4/24/2005 20:34'!
title
	^self sw2page title.! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 4/24/2005 21:48'!
title: title
	self sw2page title: title.! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'rw 6/6/2005 17:26'!
uploadDir
	"upload links must match this string"
	^'/uploads/'! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 4/22/2005 16:49'!
url
	^url! !

!PRSwikiPageWrapper methodsFor: 'private' stamp: 'mim 4/22/2005 14:54'!
url: aUrl
	url := aUrl! !

PRCommand subclass: #PRImportCommand
	instanceVariableNames: 'url strategy fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRImportCommand commentStamp: '<historical>' prior: 0!
Extends from PRCommand. Read the comment in PRCommand for more infos!!!

!PRImportCommand class methodsFor: 'converting' stamp: 'FW 6/14/2005 22:36'!
asLabel
	^PRImportCommand defaultTitle.! !

!PRImportCommand class methodsFor: 'accessing-configuration' stamp: 'FW 6/18/2005 20:24'!
defaultFileSize
	"in KB"
	^'200'! !

!PRImportCommand class methodsFor: 'accessing-configuration' stamp: 'FW 6/18/2005 20:44'!
defaultStrategy
	^'flat'! !

!PRImportCommand class methodsFor: 'accessing-configuration' stamp: 'FW 6/10/2005 11:24'!
defaultTitle
	^'Import Swiki'! !

!PRImportCommand class methodsFor: 'accessing-configuration' stamp: 'FW 4/23/2005 10:20'!
defaultUrl
	^'http://localhost:8888/mock/1'.! !

!PRImportCommand class methodsFor: 'accessing-description' stamp: 'FW 6/18/2005 20:43'!
descriptionFileSize
	^(MANumberDescription selector: #fileSize label: 'Max. size of uploaded files (in KB)' priority: 102) beRequired.

! !

!PRImportCommand class methodsFor: 'accessing-description' stamp: 'FW 6/14/2005 22:36'!
descriptionStrategy
	^(MASingleSelectionDescription selector: #strategy label: 'Kind of Import' priority: 105)
		componentClass: MARadioGroupComponent;
		options: #('flat' 'hierarchically');
		beRequired.

	! !

!PRImportCommand class methodsFor: 'accessing-description' stamp: 'mim 6/7/2005 17:48'!
descriptionUrl
	| description attributes |
	
	description := (MAStringDescription selector: #url label: 'Swiki URL' priority: 100) beRequired.
	attributes := description attributes.
	attributes at: 'size' put: 50.
	description attributes: attributes.

	^description
! !

!PRImportCommand class methodsFor: 'testing' stamp: 'rw 4/12/2005 10:47'!
isAbstract
	^false! !

!PRImportCommand class methodsFor: 'testing' stamp: 'mim 6/15/2005 17:38'!
isValidIn: aContext
	"If I return true you see my compenent in the commands panel"
	^super isValidIn: aContext! !

!PRImportCommand methodsFor: 'converting' stamp: 'FW 6/14/2005 22:37'!
asComponent
   "I override the asComponent method of PRCommand in order to prevent that there are a save and cancel button"
   ^super asComponent initializeDecoration addDecoration: (MAFormDecoration new addButton: #save label:'Import');
		addDecoration: (PRValidationDecoration new);
		yourself.  
	
	
! !

!PRImportCommand methodsFor: 'converting' stamp: 'FW 6/10/2005 11:25'!
asLabel
	"This is the title of the ImportCommand page."
	^PRImportCommand defaultTitle.! !

!PRImportCommand methodsFor: 'events' stamp: 'mim 6/16/2005 08:25'!
doExecute
	"Start the swiki import."
	
	| importer |
	super doExecute.

	"Create the proper importer instance."
	self strategy = #flat
		ifTrue: [ importer := PRFlatImporter root: self root context: self context].

	self strategy = #hierarchically
		ifTrue: [ importer := PRTreeImporter root: self root context: self context].	

	"Start import"	
	importer fileSize: self fileSize.		
	importer importSwikiFromUrl: self url.
! !

!PRImportCommand methodsFor: 'events' stamp: 'mim 6/16/2005 08:23'!
doInitialize
	super doInitialize.
	self url: self class defaultUrl.
	self strategy: self class defaultStrategy.
	self fileSize: self class defaultFileSize.
! !

!PRImportCommand methodsFor: 'events' stamp: 'FW 6/18/2005 20:40'!
doValidate
	"Check that the url is valid: If the response is a stream the url should be ok. If
	the response is a string the url is invalid."

	| response |
	super doValidate.
	response := PRConnectionProvider uniqueInstance httpGet: self url
				accept: 'text/html'.
	response class == String 
		ifTrue: [self error: 'Invalid url: ' , self url printString].
	self fileSize < 0 ifTrue:[self error: 'Enter a positive max. file size'].
	! !

!PRImportCommand methodsFor: 'private' stamp: 'mim 6/16/2005 08:24'!
fileSize
	^fileSize! !

!PRImportCommand methodsFor: 'private' stamp: 'FW 6/18/2005 20:25'!
fileSize: aNumber
     "aNumber is in kilobytes"
	fileSize := aNumber asInteger.! !

!PRImportCommand methodsFor: 'private' stamp: 'FW 6/18/2005 18:26'!
strategy
	^strategy
           
	! !

!PRImportCommand methodsFor: 'private' stamp: 'FW 6/18/2005 18:26'!
strategy: aSymbol.
	strategy:= aSymbol.
           
	! !

!PRImportCommand methodsFor: 'private' stamp: 'mim 4/14/2005 15:38'!
url
	"Returns the url of the swiki that should be imported."
	^url.! !

!PRImportCommand methodsFor: 'private' stamp: 'mim 4/14/2005 15:37'!
url: aUrl
	"Set the url of the swiki that you want to import"
	url := aUrl.! !

PRCommand subclass: #PRNewPageCommand
	instanceVariableNames: 'parent subpage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRNewPageCommand commentStamp: '<historical>' prior: 0!
I create new pages, I inherit of PRCommand for persistency and loggin reasons.!

!PRNewPageCommand class methodsFor: 'testing' stamp: 'rw 6/14/2005 16:42'!
isAbstract
	^ true! !

!PRNewPageCommand class methodsFor: 'as yet unclassified' stamp: 'rw 6/14/2005 16:47'!
new
	"Workaround. Do NOT check if Command is abstract, It need to be abstact, else it is shown on the html page"
	^ self basicNew initialize.! !

!PRNewPageCommand methodsFor: 'events' stamp: 'rw 6/14/2005 16:20'!
doExecute
	super doExecute.
	self structure children
		add: (self subpage).! !

!PRNewPageCommand methodsFor: 'accessing' stamp: 'rw 6/14/2005 16:27'!
parent
	^parent! !

!PRNewPageCommand methodsFor: 'accessing' stamp: 'rw 6/14/2005 16:27'!
parent: anObject
	parent := anObject! !

!PRNewPageCommand methodsFor: 'accessing' stamp: 'rw 6/14/2005 16:17'!
subpage
	^subpage! !

!PRNewPageCommand methodsFor: 'accessing' stamp: 'rw 6/14/2005 16:17'!
subpage: anObject
	subpage := anObject! !

SmaCCScanner subclass: #PRLinkScanner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRLinkScanner class methodsFor: 'generated-comments' stamp: 'mim 6/17/2005 09:33'!
scannerDefinitionComment

	"<newline>				: \r \n | \n | \r ;
<blankline>				: <newline> <newline> ;

<alias>					: \> ;
<linkText>				: [^\*\>\r\n@]+ ;	

<anchorTarget>			: @ [^\r\n]+ ;
																					
<email>					: \* <linkText> @ <linkText> \. [a-zA-z]+ \*;
					
<linkHttp>				: \* (<linkText> <alias>)? http\:// <linkText> \* ;
<linkFtp>				: \* (<linkText> <alias>)? ftp\:// <linkText> \* ; 
<linkFile>				: \*\+ (<linkText> <alias>)? <linkText> \+\* ;
<link>					: \* <linkText> \* ;
<linkWithAlias>			: \* (<linkText> <alias>)+ <linkText> \* ;
<anchor>				: \* @ <linkText> \* ;
<remoteAnchor>			: \* <linkText> @ <linkText> \* ;
<anchorWithAlias>		: \* (<linkText> <alias>)+ @ <linkText> \* ;
<remoteAnchorWithAlias>	: \* (<linkText> <alias>)+ <linkText> @ <linkText> \* ;
<nonLinkStart>			: \*\* | \\ [\*\=\!!\#\-\|];
			
<text>					: [^\r\n\*]+ ;
<any> 					: . ;
"! !

!PRLinkScanner methodsFor: 'generated-tokens' stamp: 'mim 6/17/2005 09:33'!
emptySymbolTokenId
	^38! !

!PRLinkScanner methodsFor: 'generated-tokens' stamp: 'mim 6/17/2005 09:33'!
errorTokenId
	^39! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
keywordFor: aString 
	^aString asUppercase! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan1
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: 
			[
			[self step.
			currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $+ and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
					whileTrue.
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(12)].
			^self reportLastMatch].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan10
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $S) 
												or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
		ifTrue: [^self scan7].
	(currentCharacter == $T or: [currentCharacter == $t]) 
		ifTrue: [^self scan14].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan11
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $E) or: 
													[currentCharacter == $G or: 
															[(currentCharacter between: $I and: $e) 
																or: [currentCharacter == $g or: [currentCharacter >= $i]]]]]]]]]) 
		ifTrue: [^self scan12].
	(currentCharacter == $F or: [currentCharacter == $f]) 
		ifTrue: 
			[self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $+ and: $=) or: 
											[currentCharacter == $? or: 
													[(currentCharacter between: $A and: $S) 
														or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
				ifTrue: [^self scan12].
			(currentCharacter == $T or: [currentCharacter == $t]) 
				ifTrue: 
					[self step.
					(currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $)) or: 
											[(currentCharacter between: $+ and: $=) or: 
													[currentCharacter == $? or: 
															[(currentCharacter between: $A and: $O) 
																or: [(currentCharacter between: $Q and: $o) or: [currentCharacter >= $q]]]]]]]) 
						ifTrue: [^self scan12].
					(currentCharacter == $P or: [currentCharacter == $p]) 
						ifTrue: 
							[self step.
							(currentCharacter <= $	 or: 
									[(currentCharacter between: $ and: $) or: 
											[(currentCharacter between: $ and: $)) or: 
													[(currentCharacter between: $+ and: $9) or: 
															[(currentCharacter between: $; and: $=) 
																or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
								ifTrue: [^self scan12].
							currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
							currentCharacter == $: 
								ifTrue: 
									[self step.
									(currentCharacter <= $	 or: 
											[(currentCharacter between: $ and: $) or: 
													[(currentCharacter between: $ and: $)) or: 
															[(currentCharacter between: $+ and: $.) or: 
																	[(currentCharacter between: $0 and: $=) 
																		or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
										ifTrue: [^self scan12].
									currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
									currentCharacter == $/ 
										ifTrue: 
											[self step.
											(currentCharacter <= $	 or: 
													[(currentCharacter between: $ and: $) or: 
															[(currentCharacter between: $ and: $)) or: 
																	[(currentCharacter between: $+ and: $.) or: 
																			[(currentCharacter between: $0 and: $=) 
																				or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
												ifTrue: [^self scan12].
											currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
											currentCharacter == $/ 
												ifTrue: 
													[self step.
													(currentCharacter <= $	 or: 
															[(currentCharacter between: $ and: $) or: 
																	[(currentCharacter between: $ and: $)) or: 
																			[(currentCharacter between: $+ and: $=) 
																				or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
														ifTrue: 
															[
															[self step.
															currentCharacter <= $	 or: 
																	[(currentCharacter between: $ and: $) or: 
																			[(currentCharacter between: $ and: $)) or: 
																					[(currentCharacter between: $+ and: $=) 
																						or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
																	whileTrue.
															currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(6 9)].
															currentCharacter == $> ifTrue: [^self scan13].
															currentCharacter == $@ ifTrue: [^self scan2].
															^self reportLastMatch].
													currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
													currentCharacter == $> ifTrue: [^self scan13].
													currentCharacter == $@ ifTrue: [^self scan2].
													^self reportLastMatch].
											currentCharacter == $> ifTrue: [^self scan13].
											currentCharacter == $@ ifTrue: [^self scan2].
											^self reportLastMatch].
									currentCharacter == $> ifTrue: [^self scan13].
									currentCharacter == $@ ifTrue: [^self scan2].
									^self reportLastMatch].
							currentCharacter == $> ifTrue: [^self scan13].
							currentCharacter == $@ ifTrue: [^self scan2].
							^self reportLastMatch].
					currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
					currentCharacter == $> ifTrue: [^self scan13].
					currentCharacter == $@ ifTrue: [^self scan2].
					^self reportLastMatch].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
			currentCharacter == $> ifTrue: [^self scan13].
			currentCharacter == $@ ifTrue: [^self scan2].
			^self reportLastMatch].
	(currentCharacter == $H or: [currentCharacter == $h]) 
		ifTrue: 
			[self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $+ and: $=) or: 
											[currentCharacter == $? or: 
													[(currentCharacter between: $A and: $S) 
														or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
				ifTrue: [^self scan12].
			(currentCharacter == $T or: [currentCharacter == $t]) 
				ifTrue: 
					[self step.
					(currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $)) or: 
											[(currentCharacter between: $+ and: $=) or: 
													[currentCharacter == $? or: 
															[(currentCharacter between: $A and: $S) 
																or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
						ifTrue: [^self scan12].
					(currentCharacter == $T or: [currentCharacter == $t]) 
						ifTrue: 
							[self step.
							(currentCharacter <= $	 or: 
									[(currentCharacter between: $ and: $) or: 
											[(currentCharacter between: $ and: $)) or: 
													[(currentCharacter between: $+ and: $=) or: 
															[currentCharacter == $? or: 
																	[(currentCharacter between: $A and: $O) 
																		or: [(currentCharacter between: $Q and: $o) or: [currentCharacter >= $q]]]]]]]) 
								ifTrue: [^self scan12].
							(currentCharacter == $P or: [currentCharacter == $p]) 
								ifTrue: 
									[self step.
									(currentCharacter <= $	 or: 
											[(currentCharacter between: $ and: $) or: 
													[(currentCharacter between: $ and: $)) or: 
															[(currentCharacter between: $+ and: $9) or: 
																	[(currentCharacter between: $; and: $=) 
																		or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
										ifTrue: [^self scan12].
									currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
									currentCharacter == $: 
										ifTrue: 
											[self step.
											(currentCharacter <= $	 or: 
													[(currentCharacter between: $ and: $) or: 
															[(currentCharacter between: $ and: $)) or: 
																	[(currentCharacter between: $+ and: $.) or: 
																			[(currentCharacter between: $0 and: $=) 
																				or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
												ifTrue: [^self scan12].
											currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
											currentCharacter == $/ 
												ifTrue: 
													[self step.
													(currentCharacter <= $	 or: 
															[(currentCharacter between: $ and: $) or: 
																	[(currentCharacter between: $ and: $)) or: 
																			[(currentCharacter between: $+ and: $.) or: 
																					[(currentCharacter between: $0 and: $=) 
																						or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
														ifTrue: [^self scan12].
													currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
													currentCharacter == $/ 
														ifTrue: 
															[self step.
															(currentCharacter <= $	 or: 
																	[(currentCharacter between: $ and: $) or: 
																			[(currentCharacter between: $ and: $)) or: 
																					[(currentCharacter between: $+ and: $=) 
																						or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
																ifTrue: 
																	[
																	[self step.
																	currentCharacter <= $	 or: 
																			[(currentCharacter between: $ and: $) or: 
																					[(currentCharacter between: $ and: $)) or: 
																							[(currentCharacter between: $+ and: $=) 
																								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
																			whileTrue.
																	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(5 9)].
																	currentCharacter == $> ifTrue: [^self scan13].
																	currentCharacter == $@ ifTrue: [^self scan2].
																	^self reportLastMatch].
															currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
															currentCharacter == $> ifTrue: [^self scan13].
															currentCharacter == $@ ifTrue: [^self scan2].
															^self reportLastMatch].
													currentCharacter == $> ifTrue: [^self scan13].
													currentCharacter == $@ ifTrue: [^self scan2].
													^self reportLastMatch].
											currentCharacter == $> ifTrue: [^self scan13].
											currentCharacter == $@ ifTrue: [^self scan2].
											^self reportLastMatch].
									currentCharacter == $> ifTrue: [^self scan13].
									currentCharacter == $@ ifTrue: [^self scan2].
									^self reportLastMatch].
							currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
							currentCharacter == $> ifTrue: [^self scan13].
							currentCharacter == $@ ifTrue: [^self scan2].
							^self reportLastMatch].
					currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
					currentCharacter == $> ifTrue: [^self scan13].
					currentCharacter == $@ ifTrue: [^self scan2].
					^self reportLastMatch].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
			currentCharacter == $> ifTrue: [^self scan13].
			currentCharacter == $@ ifTrue: [^self scan2].
			^self reportLastMatch].
	currentCharacter == $@ ifTrue: [^self scan1].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan12
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan13
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan12].
	currentCharacter == $@ ifTrue: [^self scan1].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan14
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $O) 
												or: [(currentCharacter between: $Q and: $o) or: [currentCharacter >= $q]]]]]]]) 
		ifTrue: [^self scan7].
	(currentCharacter == $P or: [currentCharacter == $p]) 
		ifTrue: [^self scan15].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan15
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $9) or: 
									[(currentCharacter between: $; and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
		ifTrue: [^self scan7].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $: ifTrue: [^self scan16].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan16
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $.) or: 
									[(currentCharacter between: $0 and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
		ifTrue: [^self scan7].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $/ ifTrue: [^self scan17].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan17
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $.) or: 
									[(currentCharacter between: $0 and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
		ifTrue: [^self scan7].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $/ ifTrue: [^self scan18].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan18
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan19].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan19
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(5 8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan2
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: 
			[
			[self step.
			currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $+ and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
					whileTrue.
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(13)].
			^self reportLastMatch].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan20
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $-) or: 
									[(currentCharacter between: $/ and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(11)].
	currentCharacter == $. ifTrue: [^self scan21].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan21
	
	[self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $-) or: 
									[(currentCharacter between: $/ and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= ${]]]]]]) 
		ifTrue: [^self scan20].
	(currentCharacter between: $A and: $z) 
		ifTrue: 
			[
			[self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $+ and: $-) or: 
											[(currentCharacter between: $/ and: $=) 
												or: [currentCharacter == $? or: [currentCharacter >= ${]]]]]]) 
				ifTrue: [^self scan20].
			currentCharacter between: $A and: $z] 
					whileTrue.
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(4 11)].
			currentCharacter == $. ifTrue: [^self scan21].
			^self reportLastMatch].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(11)].
	currentCharacter == $.] 
			whileTrue.
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan22
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $O) 
												or: [(currentCharacter between: $Q and: $o) or: [currentCharacter >= $q]]]]]]]) 
		ifTrue: [^self scan7].
	(currentCharacter == $P or: [currentCharacter == $p]) 
		ifTrue: [^self scan23].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan23
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $9) or: 
									[(currentCharacter between: $; and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
		ifTrue: [^self scan7].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $: ifTrue: [^self scan24].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan24
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $.) or: 
									[(currentCharacter between: $0 and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
		ifTrue: [^self scan7].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $/ ifTrue: [^self scan25].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan25
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $.) or: 
									[(currentCharacter between: $0 and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
		ifTrue: [^self scan7].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $/ ifTrue: [^self scan26].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan26
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan27].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan27
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(6 8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan28
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $+ ifTrue: [^self scan29].
	currentCharacter == $> ifTrue: [^self scan30].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan29
	
	[self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan28].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(7 8)].
	currentCharacter == $+] 
			whileTrue.
	currentCharacter == $> ifTrue: [^self scan30].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan3
	self recordMatch: #(16).
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $E) or: 
													[currentCharacter == $G or: 
															[(currentCharacter between: $I and: $e) 
																or: [currentCharacter == $g or: [currentCharacter >= $i]]]]]]]]]) 
		ifTrue: [^self scan7].
	(currentCharacter == $F or: [currentCharacter == $f]) 
		ifTrue: [^self scan6].
	(currentCharacter == $H or: [currentCharacter == $h]) 
		ifTrue: [^self scan8].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(14)].
	currentCharacter == $+ ifTrue: [^self scan5].
	currentCharacter == $@ 
		ifTrue: 
			[self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $+ and: $=) 
										or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
				ifTrue: 
					[
					[self step.
					currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $)) or: 
											[(currentCharacter between: $+ and: $=) 
												or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
							whileTrue.
					currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(10)].
					^self reportLastMatch].
			^self reportLastMatch].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan30
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $E) or: 
													[currentCharacter == $G or: 
															[(currentCharacter between: $I and: $e) 
																or: [currentCharacter == $g or: [currentCharacter >= $i]]]]]]]]]) 
		ifTrue: [^self scan33].
	(currentCharacter == $F or: [currentCharacter == $f]) 
		ifTrue: [^self scan31].
	(currentCharacter == $H or: [currentCharacter == $h]) 
		ifTrue: [^self scan32].
	currentCharacter == $@ ifTrue: [^self scan1].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan31
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $S) 
												or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
		ifTrue: [^self scan33].
	(currentCharacter == $T or: [currentCharacter == $t]) 
		ifTrue: [^self scan39].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $+ ifTrue: [^self scan34].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan32
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $S) 
												or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
		ifTrue: [^self scan33].
	(currentCharacter == $T or: [currentCharacter == $t]) 
		ifTrue: [^self scan35].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $+ ifTrue: [^self scan34].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan33
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $+ ifTrue: [^self scan34].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan34
	
	[self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan33].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(7 9)].
	currentCharacter == $+] 
			whileTrue.
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan35
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $S) 
												or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
		ifTrue: [^self scan33].
	(currentCharacter == $T or: [currentCharacter == $t]) 
		ifTrue: [^self scan36].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $+ ifTrue: [^self scan34].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan36
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $O) 
												or: [(currentCharacter between: $Q and: $o) or: [currentCharacter >= $q]]]]]]]) 
		ifTrue: [^self scan33].
	(currentCharacter == $P or: [currentCharacter == $p]) 
		ifTrue: 
			[self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $, and: $9) or: 
											[(currentCharacter between: $; and: $=) 
												or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
				ifTrue: [^self scan33].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
			currentCharacter == $+ ifTrue: [^self scan34].
			currentCharacter == $: 
				ifTrue: 
					[self step.
					(currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $)) or: 
											[(currentCharacter between: $, and: $.) or: 
													[(currentCharacter between: $0 and: $=) 
														or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
						ifTrue: [^self scan33].
					currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
					currentCharacter == $+ ifTrue: [^self scan34].
					currentCharacter == $/ 
						ifTrue: 
							[self step.
							(currentCharacter <= $	 or: 
									[(currentCharacter between: $ and: $) or: 
											[(currentCharacter between: $ and: $)) or: 
													[(currentCharacter between: $, and: $.) or: 
															[(currentCharacter between: $0 and: $=) 
																or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
								ifTrue: [^self scan33].
							currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
							currentCharacter == $+ ifTrue: [^self scan34].
							currentCharacter == $/ 
								ifTrue: 
									[self step.
									(currentCharacter <= $	 or: 
											[(currentCharacter between: $ and: $) or: 
													[(currentCharacter between: $ and: $)) or: 
															[(currentCharacter between: $, and: $=) 
																or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
										ifTrue: [^self scan38].
									currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
									currentCharacter == $+ ifTrue: [^self scan37].
									currentCharacter == $> ifTrue: [^self scan13].
									currentCharacter == $@ ifTrue: [^self scan2].
									^self reportLastMatch].
							currentCharacter == $> ifTrue: [^self scan13].
							currentCharacter == $@ ifTrue: [^self scan2].
							^self reportLastMatch].
					currentCharacter == $> ifTrue: [^self scan13].
					currentCharacter == $@ ifTrue: [^self scan2].
					^self reportLastMatch].
			currentCharacter == $> ifTrue: [^self scan13].
			currentCharacter == $@ ifTrue: [^self scan2].
			^self reportLastMatch].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $+ ifTrue: [^self scan34].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan37
	
	[self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan38].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(5 7 9)].
	currentCharacter == $+] 
			whileTrue.
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan38
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(5 9)].
	currentCharacter == $+ ifTrue: [^self scan37].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan39
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $O) 
												or: [(currentCharacter between: $Q and: $o) or: [currentCharacter >= $q]]]]]]]) 
		ifTrue: [^self scan33].
	(currentCharacter == $P or: [currentCharacter == $p]) 
		ifTrue: 
			[self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $)) or: 
									[(currentCharacter between: $, and: $9) or: 
											[(currentCharacter between: $; and: $=) 
												or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
				ifTrue: [^self scan33].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
			currentCharacter == $+ ifTrue: [^self scan34].
			currentCharacter == $: 
				ifTrue: 
					[self step.
					(currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) or: 
									[(currentCharacter between: $ and: $)) or: 
											[(currentCharacter between: $, and: $.) or: 
													[(currentCharacter between: $0 and: $=) 
														or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
						ifTrue: [^self scan33].
					currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
					currentCharacter == $+ ifTrue: [^self scan34].
					currentCharacter == $/ 
						ifTrue: 
							[self step.
							(currentCharacter <= $	 or: 
									[(currentCharacter between: $ and: $) or: 
											[(currentCharacter between: $ and: $)) or: 
													[(currentCharacter between: $, and: $.) or: 
															[(currentCharacter between: $0 and: $=) 
																or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]]) 
								ifTrue: [^self scan33].
							currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
							currentCharacter == $+ ifTrue: [^self scan34].
							currentCharacter == $/ 
								ifTrue: 
									[self step.
									(currentCharacter <= $	 or: 
											[(currentCharacter between: $ and: $) or: 
													[(currentCharacter between: $ and: $)) or: 
															[(currentCharacter between: $, and: $=) 
																or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
										ifTrue: [^self scan41].
									currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
									currentCharacter == $+ ifTrue: [^self scan40].
									currentCharacter == $> ifTrue: [^self scan13].
									currentCharacter == $@ ifTrue: [^self scan2].
									^self reportLastMatch].
							currentCharacter == $> ifTrue: [^self scan13].
							currentCharacter == $@ ifTrue: [^self scan2].
							^self reportLastMatch].
					currentCharacter == $> ifTrue: [^self scan13].
					currentCharacter == $@ ifTrue: [^self scan2].
					^self reportLastMatch].
			currentCharacter == $> ifTrue: [^self scan13].
			currentCharacter == $@ ifTrue: [^self scan2].
			^self reportLastMatch].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(9)].
	currentCharacter == $+ ifTrue: [^self scan34].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan4
	self recordMatch: #(2).
	self step.
	currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #(2)].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan40
	
	[self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan41].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(6 7 9)].
	currentCharacter == $+] 
			whileTrue.
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan41
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $, and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(6 9)].
	currentCharacter == $+ ifTrue: [^self scan40].
	currentCharacter == $> ifTrue: [^self scan13].
	currentCharacter == $@ ifTrue: [^self scan2].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan5
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan28].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan6
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $S) 
												or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
		ifTrue: [^self scan7].
	(currentCharacter == $T or: [currentCharacter == $t]) 
		ifTrue: [^self scan22].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan7
	
	[self step.
	currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]] 
			whileTrue.
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan8
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) or: 
									[currentCharacter == $? or: 
											[(currentCharacter between: $A and: $S) 
												or: [(currentCharacter between: $U and: $s) or: [currentCharacter >= $u]]]]]]]) 
		ifTrue: [^self scan7].
	(currentCharacter == $T or: [currentCharacter == $t]) 
		ifTrue: [^self scan10].
	currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(8)].
	currentCharacter == $> ifTrue: [^self scan11].
	currentCharacter == $@ ifTrue: [^self scan9].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scan9
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $=) 
								or: [currentCharacter == $? or: [currentCharacter >= $A]]]]]) 
		ifTrue: [^self scan20].
	^self reportLastMatch! !

!PRLinkScanner methodsFor: 'generated-scanner' stamp: 'mim 6/17/2005 09:33'!
scanForToken
	self step.
	(currentCharacter <= $	 or: 
			[(currentCharacter between: $ and: $) or: 
					[(currentCharacter between: $ and: $)) or: 
							[(currentCharacter between: $+ and: $?) 
								or: [(currentCharacter between: $A and: $[) or: [currentCharacter >= $]]]]]]) 
		ifTrue: 
			[self recordMatch: #(15 16).
			self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) 
						or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]) 
				ifTrue: 
					[
					[self recordMatch: #(15).
					self step.
					currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) 
								or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $
 
		ifTrue: 
			[self recordMatch: #(1 16).
			self step.
			currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #(2)].
			currentCharacter == $
 ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $
 
		ifTrue: 
			[self recordMatch: #(1 16).
			self step.
			currentCharacter == $
 
				ifTrue: 
					[self recordMatch: #(1 2).
					self step.
					currentCharacter == $
 ifTrue: [^self recordAndReportMatch: #(2)].
					currentCharacter == $
 ifTrue: [^self scan4].
					^self reportLastMatch].
			currentCharacter == $
 ifTrue: [^self scan4].
			^self reportLastMatch].
	currentCharacter == $* ifTrue: [^self scan3].
	currentCharacter == $@ 
		ifTrue: 
			[self recordMatch: #(15 16).
			self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) 
						or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]) 
				ifTrue: 
					[
					[self recordMatch: #(3 15).
					self step.
					currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) 
								or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]] 
							whileTrue.
					currentCharacter == $* 
						ifTrue: 
							[
							[self recordMatch: #(3).
							self step.
							currentCharacter <= $	 
								or: [(currentCharacter between: $ and: $) or: [currentCharacter >= $]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $* 
				ifTrue: 
					[
					[self recordMatch: #(3).
					self step.
					currentCharacter <= $	 
						or: [(currentCharacter between: $ and: $) or: [currentCharacter >= $]]] 
							whileTrue.
					^self reportLastMatch].
			^self reportLastMatch].
	currentCharacter == $\ 
		ifTrue: 
			[self recordMatch: #(15 16).
			self step.
			(currentCharacter <= $	 or: 
					[(currentCharacter between: $ and: $) or: 
							[(currentCharacter between: $ and: $ ) or: 
									[currentCharacter == $" or: 
											[(currentCharacter between: $$ and: $)) or: 
													[(currentCharacter between: $+ and: $,) or: 
															[(currentCharacter between: $. and: $<) 
																or: [(currentCharacter between: $> and: ${) or: [currentCharacter >= $}]]]]]]]]) 
				ifTrue: 
					[
					[self recordMatch: #(15).
					self step.
					currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) 
								or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]] 
							whileTrue.
					^self reportLastMatch].
			(currentCharacter == $!! or: 
					[currentCharacter == $# or: 
							[currentCharacter == $- 
								or: [currentCharacter == $= or: [currentCharacter == $|]]]]) 
				ifTrue: 
					[self recordMatch: #(14 15).
					self step.
					(currentCharacter <= $	 or: 
							[(currentCharacter between: $ and: $) 
								or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]) 
						ifTrue: 
							[
							[self recordMatch: #(15).
							self step.
							currentCharacter <= $	 or: 
									[(currentCharacter between: $ and: $) 
										or: [(currentCharacter between: $ and: $)) or: [currentCharacter >= $+]]]] 
									whileTrue.
							^self reportLastMatch].
					^self reportLastMatch].
			currentCharacter == $* ifTrue: [^self recordAndReportMatch: #(14)].
			^self reportLastMatch].
	^self reportLastMatch! !

PRWidget subclass: #PRToolsWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer'!

!PRToolsWidget commentStamp: '<historical>' prior: 0!
I am the gui-widget!

!PRToolsWidget class methodsFor: 'testing' stamp: 'mim 4/14/2005 15:57'!
isAbstract
	^false! !

!PRToolsWidget methodsFor: 'rendering' stamp: 'FW 5/10/2005 19:29'!
renderContentOn: html
	html divClass: 'box tools' with: [
		html heading: 'Tools'.
		html
			anchorToStructure: self context structure 
			command: PRImportCommand new do: PRImportCommand asLabel.].
		! !

TestCase subclass: #PRMockTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRMockTestCase commentStamp: '<historical>' prior: 0!
For the unit tests we use a MockSocket. For each test we need to 
tell the ConnectionProvider to use the Mock Object. This is done
in the setUp and tearDown method.

For convenience all test should extend this class.!

PRMockTestCase subclass: #PRConnectionProviderTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRConnectionProviderTest methodsFor: 'tests' stamp: 'FW 6/18/2005 11:55'!
testIsLocked
	"This is a normal page: http://www.mock.ch/mock/1"

	self 
		assert: (PRConnectionProvider uniqueInstance 
				isLocked: (PRConnectionProvider uniqueInstance 
						httpGet: PRMockSocket rootPath , '/1')) 
					= false.

	"This is the mock of a 401 page: http://www.mock.ch/mock/401"
	self 
		assert: (PRConnectionProvider uniqueInstance 
				isLocked: (PRConnectionProvider uniqueInstance 
						httpGet: PRMockSocket rootPath , '/401')) 
					= true! !

PRMockTestCase subclass: #PRImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRImporterTest methodsFor: 'as yet unclassified' stamp: 'FW 6/18/2005 19:31'!
testAssureUrlIsValid
	| importer inputUrl outputUrl |
	importer := PRTreeImporter root: nil context: nil.
	
	"Url without /1 ending"
	inputUrl := PRMockSocket rootPath.
	outputUrl := PRMockSocket rootPath, '/1'.
	self assert: (importer assureUrlIsValid: inputUrl) = outputUrl.
	
	"Url with /1 ending"
	inputUrl := PRMockSocket rootPath, '/1'.
	outputUrl := PRMockSocket rootPath, '/1'.
	self assert: (importer assureUrlIsValid: inputUrl) = outputUrl.
	
	"Url with /aNumber ending"
	inputUrl := PRMockSocket rootPath, '/2'.
	outputUrl := PRMockSocket rootPath, '/2'.
	self assert: (importer assureUrlIsValid: inputUrl) = outputUrl.! !

!PRMockTestCase methodsFor: 'tests' stamp: 'FW 6/18/2005 11:43'!
setUp
	"Change to mock environment"

	PRSwiki13Mock initialize.
	PRConnectionProvider uniqueInstance htmlProvider: PRSwiki13Mock! !

!PRMockTestCase methodsFor: 'tests' stamp: 'FW 6/18/2005 11:43'!
tearDown
	"Switch back to normal Socket class"

	PRConnectionProvider uniqueInstance htmlProvider: HTTPSocket! !

PRMockTestCase subclass: #PRSwikiLinkParserTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRSwikiLinkParserTest commentStamp: '<historical>' prior: 0!
Tests for the SwikiLinkParser!

!PRSwikiLinkParserTest methodsFor: 'as yet unclassified' stamp: 'mim 6/17/2005 13:41'!
testAnchor
	"Smallwiki doesn't know anchors. So we need to change
	the links to something that smallwiki can understand."
	
	| parser input output |

	input := 
		'-*How do I get started?>A Page@START*
		-*How do I use cvs remotely with ssh?>@SSH*
		-*@SSH*
		-*A Page@SSH*
		
		* Not a Alias > Not a Page @ Not a Anchor
		And some more text'.


	output := 
		'-*How do I get started?>A Page*
		-<b>How do I use cvs remotely with ssh?</b>
		-SSH <i>(This was an anchor)</i>
		-*A Page*
		
		* Not a Alias > Not a Page @ Not a Anchor
		And some more text'.

	parser := PRFlatLinkParser on: (ReadStream on: input).
	parser parse.
	self assert: parser contents = output.! !

!PRSwikiLinkParserTest methodsFor: 'as yet unclassified' stamp: 'mim 6/17/2005 13:42'!
testAnchorTarget
	"Smallwiki doesn't know anchors. So we remove the anchor tags."
	
	| parser input output |

"IMPORTANT: Do not indent these strings!!!!!!"
input := 
'@Anchor at top of page
-*How do I get started?>A Page@START*
-*How do I use cvs remotely with ssh?>@SSH* @Not an achor (since not at start of line
-*@SSH*
-*A Page@SSH*

@Anchor with many strange characters * @ # < >


@Anchor after some empty lines



@Anchor after more empty lines

* Not a Alias > Not a Page @ Not a Anchor
And some more text'.


output := 
'
-*How do I get started?>A Page*
-<b>How do I use cvs remotely with ssh?</b> @Not an achor (since not at start of line
-SSH <i>(This was an anchor)</i>
-*A Page*










* Not a Alias > Not a Page @ Not a Anchor
And some more text'.

	parser := PRFlatLinkParser on: (ReadStream on: input).
	parser parse.
	self assert: parser contents = output.! !

!PRSwikiLinkParserTest methodsFor: 'as yet unclassified' stamp: 'mim 6/17/2005 13:41'!
testEmail
	
	| parser input output |

	input := 
		'-*How do I get started?>A Page*
		-*scg@iam.unibe.ch*
		-*A link*
		-*An alias>A link*
		
		* Not a Alias > Not a Page @ Not a Anchor
		And some more text'.


	output := 
		'-*How do I get started?>/A Page*
		-*scg@iam.unibe.ch*
		-*A link>/A link*
		-*An alias>/A link*
		
		* Not a Alias > Not a Page @ Not a Anchor
		And some more text'.

	parser := PRFlatLinkParser on: (ReadStream on: input).
	parser parse.
	self assert: parser contents = output.! !

!PRSwikiLinkParserTest methodsFor: 'as yet unclassified' stamp: 'mim 6/17/2005 13:41'!
testLinkUpdating
	| parser input output |

	input := 
		'*ftp://st.cs.uiuc.edu/Smalltalk/Squeak/3.0/mac/*
		*Alias>http://minnow.cc.gatech.edu/squeak/298*
		*http://sourceforge.net/projects/squeak*
		*Internal Link>a link with alias*
		*Internal Link > a link with alias*
		*a link without alias*
		*+A link to a File+*
		*+Alias>A link to a File+*'.


	output := 
		'*ftp://st.cs.uiuc.edu/Smalltalk/Squeak/3.0/mac/*
		*Alias>http://minnow.cc.gatech.edu/squeak/298*
		*http://sourceforge.net/projects/squeak*
		*Internal Link>/a link with alias*
		*Internal Link >/ a link with alias*
		*a link without alias>/a link without alias*
		*+A link to a File+*
		*+Alias>A link to a File+*'.

	parser := PRFlatLinkParser on: (ReadStream on: input).
	parser parse.
	self assert: parser contents = output.! !

!PRSwikiLinkParserTest methodsFor: 'as yet unclassified' stamp: 'mim 6/17/2005 13:41'!
testStarAsText
	"During the import of the scg swiki I noticed that the
	parser couldn't parse the following peace of code:
	
	-Sandro Pinna, University of Cagliari
	-*RedBit*, *Prometheo>http://www.prometheo.it/*
	-Tom Cornell, Cymfony, Inc.
	-*<html>"
	
	| parser input output |

	input := 
		'-Sandro Pinna, University of Cagliari
		-*RedBit*, *Prometheo>http://www.prometheo.it/*
		-Tom Cornell, Cymfony, Inc.
		-*<html>'.


	output := 
		'-Sandro Pinna, University of Cagliari
		-*RedBit>/RedBit*, *Prometheo>http://www.prometheo.it/*
		-Tom Cornell, Cymfony, Inc.
		-*<html>'.

	parser := PRFlatLinkParser on: (ReadStream on: input).
	parser parse.
	self assert: parser contents = output.! !

!PRSwikiLinkParserTest methodsFor: 'as yet unclassified' stamp: 'mim 6/17/2005 13:41'!
testSyntax
	| parser text |
	text := '\*  % # @ : \: | ( )'.
	parser := PRFlatLinkParser on: (ReadStream on: text).
	parser parse.
	self assert: parser contents = text! !

PRMockTestCase subclass: #PRSwikiPageWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRSwikiPageWrapperTest methodsFor: 'tests' stamp: 'FW 6/18/2005 11:55'!
testAsSw2Page
	| swPage |
	swPage := (PRSwiki13Wrapper url: PRMockSocket rootPath , '/1') asPRPage.

	"Check title"
	self assert: swPage title = 'mock Swiki'.

	"Check contents"
	self assert: swPage contents 
				= 'Congratulations!! This is a new Swiki.\\*Page 1*\*Page 2*' withCRs! !

!PRSwikiPageWrapperTest methodsFor: 'tests' stamp: 'FW 6/18/2005 11:55'!
testEqual
	"Import the same page twice. They should have same hash code
	and the = method should return true"

	| pageOne pageTwo otherPage |
	pageOne := PRSwiki13Wrapper url: PRMockSocket rootPath , '/1'.
	pageTwo := PRSwiki13Wrapper url: PRMockSocket rootPath , '/1'.
	self assert: pageOne = pageTwo.


	"This page should be different"
	otherPage := PRSwiki13Wrapper url: PRMockSocket rootPath , '/2'.
	self deny: otherPage = pageTwo! !

!PRSwikiPageWrapperTest methodsFor: 'tests' stamp: 'FW 6/18/2005 11:56'!
testGetAllInternalLinks
	| swikiPage links |
	swikiPage := PRSwiki13Wrapper url: PRMockSocket rootPath , '/1'.
	links := swikiPage getAllInternalLinks.

	"Check that we found both links"
	self assert: links size = 2.

	"Check that the links are correct"
	self assert: (links at: 1) = 'http://www.mock.com/mock/2'.
	self assert: (links at: 2) = 'http://www.mock.com/mock/3'! !

!PRSwikiPageWrapperTest methodsFor: 'tests' stamp: 'FW 6/18/2005 11:56'!
testHash
	"Import the same page twice. They should have same hash code
	and the = method should return true"

	| pageOne pageTwo otherPage |
	pageOne := PRSwiki13Wrapper url: PRMockSocket rootPath , '/1'.
	pageTwo := PRSwiki13Wrapper url: PRMockSocket rootPath , '/1'.
	self assert: pageOne hash = pageTwo hash.


	"This page should be different"
	otherPage := PRSwiki13Wrapper url: PRMockSocket rootPath , '/2'.
	self deny: otherPage hash = pageTwo hash! !

!PRSwikiPageWrapperTest methodsFor: 'tests' stamp: 'FW 6/18/2005 11:56'!
testTitle
	| pageOne otherPage |
	pageOne := PRSwiki13Wrapper url: PRMockSocket rootPath , '/1'.
	self assert: pageOne title = 'mock Swiki'.


	"This page should be different"
	otherPage := PRSwiki13Wrapper url: PRMockSocket rootPath , '/2'.
	self assert: otherPage title = 'Page 1'.
	self deny: otherPage = pageOne.


	"Two pages are equal if they have the same name"
	otherPage title: 'mock Swiki'.
	self assert: otherPage = pageOne! !

PRMockTestCase subclass: #PRTreeImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Importer-Tests'!

!PRTreeImporterTest methodsFor: 'tests' stamp: 'rw 6/18/2005 14:44'!
testImportFromUrl
	"Test that the importer imports all three pages from the MockSocket
	We except the following structure:
	
		root
		|-mock Swiki
			|-Page 1
			|-Page2
	"
	
	| importer root mockSwiki page contents kernel |
	root := PRPage title: 'root'.
	kernel := PRKernel instances first.
	importer := PRTreeImporter root: root context: (PRContext kernel: kernel).
	importer importSwikiFromUrl: PRMockSocket rootPath, '/1'.
	
	"Check that root has one child: mock Swiki"
	self assert: (root children children size = 1).
	self deny: ((root children at: 'mock Swiki') = nil).
	
	"Test that the contents is correct"
	mockSwiki := root children at: 'mock Swiki'.
	contents := 'Congratulations!! This is a new Swiki.\\*Page 1*\*Page 2*' withCRs. 
	"contents := 'Congratulations!! This is a new Swiki.\\*Page 1>/mock Swiki/Page 1*\*Page 2>/mock Swiki/Page 2*' withCRs. "
	self assert: (mockSwiki contents = contents).
		
	"Check that Swiki has two children"
	self assert: (mockSwiki children children size = 2).
	
	"Test that contents of Page 1 is correct"
	self deny: ((mockSwiki children at: 'Page 1') = nil).
	page := mockSwiki children at: 'Page 1'.
	contents :=	'I am <b>Page 1</b> with no links.' withCRs.
	self assert: (page contents withBlanksCondensed = contents withBlanksCondensed).
	
	"Test that contents of Page 2 is correct"
	self deny: ((mockSwiki children at: 'Page 2') = nil).
	page := mockSwiki children at: 'Page 2'.
	contents :=	'I am Page 2 with no links.' withCRs.
	self assert: (page contents withBlanksCondensed = contents withBlanksCondensed). 
	
! !

!PRTreeImporterTest methodsFor: 'tests' stamp: 'rw 6/16/2005 16:45'!
testUpdateLink

	| importer contents result root node1 node2 node3 kernel |
		
	root := PRPage title: 'root'.
	node1 := PRPage title: 'Page 1'.
	node2 := PRPage title: 'Page 2'.
	node3 := PRPage title: 'Page 3'.
	
	"-------------------------------------------------------------------
	Structure:
	root
		|- Page 1
		|	|- Page 2
		|- Page 3	
	--------------------------------------------------------------------"
	root children add: node1.
	node1 children add: node2.
	root children add: node3.
	kernel := PRKernel instances first.
	importer := PRTreeImporter root: root context: (PRContext kernel: kernel).
	
	"---------------------------------------------------------------------
	Test for a page that contains normal links: *Page 2*.
	Page 3 contains a link to Page 2
	----------------------------------------------------------------------"
	contents := 'Some text and a Link: *Page 2*'.
	result := 'Some text and a Link: *Page 2>/Page 1/Page 2*'.
	
	"Update the link"
	node3 contents: contents.
	importer updateLink: node2 page: node3.
	self assert: (node3 contents = result).
	
	
	"--------------------------------------------------------------------------------
	Test for a page that contains links with an alias: *alias>Page 1*
	Page 3 contains a link (with alias) to Page 2
	--------------------------------------------------------------------------------"
	contents := 'Some text and a Link: *alias>Page 2*'.
	result := 'Some text and a Link: *alias>/Page 1/Page 2*'.
	
	"Update the link"
	node3 contents: contents.
	importer updateLink: node2 page: node3.
	self assert: (node3 contents = result).! !

!PRTreeImporterTest methodsFor: 'tests' stamp: 'rw 6/18/2005 14:45'!
testUpdateLinkAfterProxyImport

	| importer root mockSwiki pageOne pageTwo pageWithLink result |

	"Create environment"		
	root := PRPage title: 'root'.
	importer := PRTreeImporter root: root context: (PRContext kernel: PRKernel new structure: root).

	"---------------------------------------------------------------------
	Import the mock swiki. Structure:
		mock Swiki
		|- Page 1
		|- Page 2
	----------------------------------------------------------------------"
	importer importSwikiFromUrl: PRMockSocket rootPath, '/1'.
	mockSwiki := root children at: 'mock Swiki'.
	pageOne := mockSwiki children at: 'Page 1'.
	pageTwo := mockSwiki children at: 'Page 2'.
	
	
	"---------------------------------------------------------------------
	Now we change the structure like this
		mock Swiki
		|- Page 1 <--- pageWithLink (*Page 1*)
		|- Page 2
	----------------------------------------------------------------------"
	pageWithLink := PRPage title: 'Page with link to page 1'.
	pageWithLink contents: 'Some text and a Link: *Page 1*'.
	result := 'Some text and a Link: *Page 1>/mock Swiki/Page 1*'.
	
	"Update the link. Create alias"
	importer updateLink: pageOne page: pageWithLink.
	self assert: (pageWithLink contents = result).


	"---------------------------------------------------------------------
	Now we change the structure like this
		mock Swiki
		|- Page 1 
		|- Page 2 <--- pageWithLink (*alias>Page 1*)
	----------------------------------------------------------------------"
	pageWithLink := PRPage title: 'Page with link to page 2'.
	pageWithLink contents: 'Some text and a Link: *My Alias>Page 2*'.
	result := 'Some text and a Link: *My Alias>/mock Swiki/Page 2*'.
	
	"Update the link. Don't change alias"
	importer updateLink: pageTwo page: pageWithLink.	
	self assert: (pageWithLink contents = result).! !
PRSwiki13Mock initialize!
PRSwiki14Mock initialize!
